SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[BulkAgent]
AS
BEGIN

	-- ACTUALIZAMOS LOS REGISTROS QUE VIENEN EN LA TEMPORAL Y YA EXISTEN EN LA TABLA AGENT
	UPDATE A
		SET A.[Name] = A_TMP.[Name],
			A.[LastModifiedDate] = GETUTCDATE(),
			A.[TimeStamp] = GETUTCDATE()
		FROM [dbo].[Agent] A (NOLOCK)
		INNER JOIN [#AgentTemp] A_TMP 
			ON A_TMP.[VCC] = A.[VCC]
				AND A_TMP.[AgentId] = A.[AgentId] 

	-- INSERTAMOS LA DATA DE LA TABLA TEMPORAL
	INSERT INTO [dbo].[Agent] ([VCC], [AgentId], [Name], [CreatedDate], [TimeStamp])
		SELECT A_TMP.[VCC], 
				A_TMP.[AgentId], 
				REPLACE(LTRIM(RTRIM(A_TMP.[Name])), '  ', ' '), 
				GETUTCDATE(), 
				GETUTCDATE()
			FROM [#AgentTemp] A_TMP (NOLOCK) 
			LEFT JOIN [dbo].[Agent] A (NOLOCK)
				ON A.[VCC] = A_TMP.[VCC]
					AND A.[AgentId] = A_TMP.[AgentId]
			WHERE A.[VCC] IS NULL

	-- ELIMINAMOS LA TABLA TEMPORAL 
	DROP TABLE [#AgentTemp]

END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
