SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[BulkInteractionQueryStudy]
AS
BEGIN
	SET NOCOUNT ON
	-- SP PARA EL VOLCADO DE RESULTADOS DE ANALISIS SEMANTICO EN ESTUDIOS

	/*
	DROP TABLE TMP_INTERACTION_QUERY_STUDY
	CREATE TABLE TMP_INTERACTION_QUERY_STUDY (
		VCC VarChar(50),
		ProcessId VarChar(50),
		StudyId VarChar(200),
		TemplateId VarChar(200), 
		TemplateThemeItemId VarChar(200),
		TranscriptionId VARCHAR(250),
		Nlu VARCHAR(250),
		IntentName VARCHAR(250),
		Total Float,
		Duration Float,
		Silence Float,
		OtherDuration Float,
		OtherSilence Float,
		Confidence Float, 
		EndDate VarChar(50),
		Channel VarChar(50),
		Campaign VarChar(100),
		ValidChar Int,
		ValidWords Int
	)
	
	--SELECT * FROM TMP_INTERACTION_QUERY_STUDY
	INSERT INTO TMP_INTERACTION_QUERY_STUDY (
		VCC, ProcessId, StudyId, TemplateId, TemplateThemeItemId, 
		TranscriptionId, Total, Duration, Silence, OtherDuration,
		OtherSilence, Confidence, EndDate, Channel, Campaign, 
		ValidChar, ValidWords
	)
		SELECT VCC, ProcessId, StudyId, TemplateId, TemplateThemeItemId, 
				TranscriptionId, Total, Duration, Silence, OtherDuration,
				OtherSilence, Confidence, EndDate, Channel, Campaign, 
				ValidChar, ValidWords
			FROM #InteractionQueryStudyTemp
	*/
	
	-- INSERTAMOS LOS RESULTADOS DE LAS INTERACCIONES DE AUDIO QUE MATCHEARON CON LA QUERY
	INSERT INTO [dbo].[InteractionQueryResult] (
		[VCC],
		[InteractionId],
		[Section],
		[Part],
		[InteractionType],
		[TranscriptionId],
		[BatchType],
		[BatchTypeId],
		[BatchTypeName],
		[AnalysisType],
		[QueryId],
		[QueryName],
		[QueryValue],
		[QueryData],
		[Matches],
		[Details],
		[CreatedDate],
		[TimeStamp]
	)
		SELECT IQST.[VCC],
				PA.[AudioId],
				PA.[Section],
				PA.[Part],
				IQST.[Channel],
				IQST.[TranscriptionId],
				'STUDY',
				IQST.[StudyId],
				IQST.[StudyId],
				'SEMANTIC',
				GQ.[Name],
				GQ.[Name],
				GQ.[Query],
				GQ.[RawData],
				IQST.[Matches],
				IQST.[MatchesDetail],
				GETUTCDATE(),
				GETUTCDATE()
			FROM [#InteractionQueryStudyTemp] IQST (NOLOCK)
			INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK)
				ON PA.[VCC] = IQST.[VCC]
					AND PA.[ProcessId] = IQST.[ProcessId]
					AND CONCAT(PA.[AudioId], '_', ISNULL(PA.[Section], '0'), '_', ISNULL(PA.[Part], '0')) = IQST.[TranscriptionId]
			INNER JOIN [dbo].[GenericQuery] GQ (NOLOCK)
				ON GQ.[VCC] = IQST.[VCC]
					AND GQ.[Name] = IQST.[TemplateThemeItemId]
			WHERE IQST.[Channel] = 'CALL'

	-- INSERTAMOS LOS RESULTADOS DE LAS INTERACCIONES DE TEXTO QUE MATCHEARON CON LA QUERY
	INSERT INTO [dbo].[InteractionQueryResult] (
		[VCC],
		[InteractionId],
		[Section],
		[Part],
		[InteractionType],
		[TranscriptionId],
		[BatchType],
		[BatchTypeId],
		[BatchTypeName],
		[AnalysisType],
		[QueryId],
		[QueryName],
		[QueryValue],
		[QueryData],
		[Matches],
		[Details],
		[CreatedDate],
		[TimeStamp]
	)
		SELECT IQST.[VCC],
				PAI.[InteractionId],
				NULL,
				NULL,
				PAI.[InteractionType],
				IQST.[TranscriptionId],
				'STUDY',
				IQST.[StudyId],
				IQST.[StudyId],
				'SEMANTIC',
				GQ.[Name],
				GQ.[Name],
				GQ.[Query],
				GQ.[RawData],
				IQST.[Matches],
				IQST.[MatchesDetail],
				GETUTCDATE(),
				GETUTCDATE()
			FROM [#InteractionQueryStudyTemp] IQST (NOLOCK)
			INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
				ON PAI.[VCC] = IQST.[VCC]
					AND PAI.[InteractionType] = IQST.[Channel]
					AND PAI.[FormattedEndDate] = IQST.[EndDate]
					AND PAI.[Campaign] = IQST.[Campaign]
					AND PAI.[ProcessId] = IQST.[ProcessId]
					AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = IQST.[TranscriptionId]
			INNER JOIN [dbo].[GenericQuery] GQ (NOLOCK)
				ON GQ.[VCC] = IQST.[VCC]
					AND GQ.[Name] = IQST.[TemplateThemeItemId]
			WHERE IQST.[Channel] <> 'CALL'
	
	-- INSERTAMOS LOS REGISTROS CALL A LA TABLA STUDYRESULTSUMMARYDETAIL
	INSERT INTO [StudyResultSummaryDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[IsMatched]
		,[CreatedDate]
		,[CreatedByUserId]
		,[TimeStamp]
		)
	SELECT
		A.[VCC]
		, A.[StudyId]
		, B.[TemplateThemeId]
		, A.[TemplateThemeItemId]
		, A.[TranscriptionId]
		, 1
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
				[VCC]
				, [ProcessId]
				, [StudyId]
				, [TemplateId]
				, [TemplateThemeItemId]
				, [TranscriptionId]
			FROM #InteractionQueryStudyTemp
			WHERE [Channel] = 'CALL'
	) A
	LEFT JOIN [TemplateThemeItem] B (nolock) 
		ON A.[VCC] = B.[VCC]
			AND A.[TemplateId] = B.[TemplateId]
			AND A.[TemplateThemeItemId] = B.Id
	LEFT JOIN [StudyResultSummaryDetail] C (nolock) 
		ON A.[VCC] = C.[VCC]
			AND A.[StudyId] = C.[StudyId]
			AND B.[TemplateThemeId] = C.[TemplateThemeId]
			AND A.[TranscriptionId] = C.[TranscriptionId]
	INNER JOIN [ProcessAudio] D (nolock) 
		ON A.[VCC] = D.[VCC]
			AND A.ProcessId = D.ProcessId
			AND CONCAT(D.[AudioId],'_',ISNULL(D.[Section], '0'),'_',ISNULL(D.[Part], '0')) = A.[TranscriptionId]
	WHERE C.[TranscriptionId] is null 
		and B.[TemplateThemeId] is not null


	-- INSERTAMOS LOS REGISTROS DE CANALES ASINCRONOS A LA TABLA STUDYRESULTSUMMARYDETAIL
	INSERT INTO [StudyResultSummaryDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[IsMatched]
		,[CreatedDate]
		,[CreatedByUserId]
		,[TimeStamp]
		)
	SELECT
		TMP_IQS.[VCC]
		, TMP_IQS.[StudyId]
		, TTI.[TemplateThemeId]
		, TMP_IQS.[TemplateThemeItemId]
		, TMP_IQS.[TranscriptionId]
		, 1
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
				[VCC]
				, [ProcessId]
				, [StudyId]
				, [TemplateId]
				, [TemplateThemeItemId]
				, [TranscriptionId]
				, [Campaign]
				, [EndDate]
				, [Channel]
			FROM #InteractionQueryStudyTemp
			-- FROM TMP_INTERACTION_QUERY_STUDY
			WHERE [Channel] <> 'CALL'
	) TMP_IQS
	LEFT JOIN [TemplateThemeItem] TTI (NOLOCK) 
		ON TMP_IQS.[VCC] = TTI.[VCC]
			AND TMP_IQS.[TemplateId] = TTI.[TemplateId]
			AND TMP_IQS.[TemplateThemeItemId] = TTI.Id
	LEFT JOIN [StudyResultSummaryDetail] SRSD (NOLOCK) 
		ON TMP_IQS.[VCC] = SRSD.[VCC]
			AND TMP_IQS.[StudyId] = SRSD.[StudyId]
			AND TTI.[TemplateThemeId] = SRSD.[TemplateThemeId]
			AND TMP_IQS.[TranscriptionId] = SRSD.[TranscriptionId]
	INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
		ON TMP_IQS.[VCC] = PAI.[VCC]
			AND PAI.[InteractionType] = TMP_IQS.[Channel]
			AND PAI.[FormattedEndDate] = TMP_IQS.[EndDate]
			AND PAI.[Campaign] = TMP_IQS.[Campaign]
			AND PAI.[ProcessId] = TMP_IQS.ProcessId
			-- AND PAI.[InteractionId] = TMP_IQS.[TranscriptionId]
			AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = TMP_IQS.[TranscriptionId]
	WHERE SRSD.[TranscriptionId] IS NULL
		AND TTI.[TemplateThemeId] IS NOT NULL
		

	-- INSERTAMOS LOS REGISTROS CALL A LA TABLA STUDYDETAIL
	INSERT INTO [StudyDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[Total]
		,[Duration]
		,[Silence]
		,[OtherDuration]
		,[OtherSilence]
		,[Confidence]
		,[IsMatched]
		,[CreatedDate]
		,[CreatedByUserId]
		,[LastModifiedDate]
		,[LastModifiedByUserId]
		,[TimeStamp]
		)
	SELECT
		A.[VCC]
		, A.[StudyId]
		, B.[TemplateThemeId]
		, A.[TemplateThemeItemId]
		, A.[TranscriptionId]
		, A.[Total]
		, A.[Duration]
		, A.[Silence]
		, A.[OtherDuration]
		, A.[OtherSilence]
		, A.[Confidence]
		, 1
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, [Total]
			, [Duration]
			, [Silence]
			, [OtherDuration]
			, [OtherSilence]
			, [Confidence]
		FROM #InteractionQueryStudyTemp
		WHERE [Channel] = 'CALL'
	) A 
	LEFT JOIN [TemplateThemeItem] B (nolock) 
		ON A.[VCC] = B.[VCC]
			AND A.[TemplateId] = B.[TemplateId]
			AND A.[TemplateThemeItemId] = B.Id
	LEFT JOIN [StudyDetail] C (nolock) 
		ON A.[VCC] = C.[VCC]
			AND A.[StudyId] = C.[StudyId]
			AND B.[TemplateThemeId] = C.[TemplateThemeId]
			AND A.[TranscriptionId] = C.[TranscriptionId]
	INNER JOIN [ProcessAudio] D (nolock) 
		ON A.[VCC] = D.[VCC]
			AND A.ProcessId = D.ProcessId
			AND CONCAT(D.[AudioId],'_',ISNULL(D.[Section], '0'),'_',ISNULL(D.[Part], '0')) = A.[TranscriptionId]
	WHERE C.[TranscriptionId] is null 
		and B.[TemplateThemeId] is not null


	-- INSERTAMOS LOS REGISTROS DE OTROS CANALES A LA TABLA STUDYRESULTSUMMARYDETAIL
	INSERT INTO [StudyDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[Total]
		,[Duration]
		,[Silence]
		,[OtherDuration]
		,[OtherSilence]
		,[Confidence]
		,[IsMatched]
		,[CreatedDate]
		,[CreatedByUserId]
		,[LastModifiedDate]
		,[LastModifiedByUserId]
		,[TimeStamp]
		)
	SELECT
		TMP_IQS.[VCC]
		, TMP_IQS.[StudyId]
		, TTI.[TemplateThemeId]
		, TMP_IQS.[TemplateThemeItemId]
		, TMP_IQS.[TranscriptionId]
		, TMP_IQS.[Total]
		, TMP_IQS.[Duration]
		, TMP_IQS.[Silence]
		, TMP_IQS.[OtherDuration]
		, TMP_IQS.[OtherSilence]
		, TMP_IQS.[Confidence]
		, 1
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, [Total]
			, [Duration]
			, [Silence]
			, [OtherDuration]
			, [OtherSilence]
			, [Confidence]
			, [Campaign]
			, [EndDate]
			, [Channel]
		FROM #InteractionQueryStudyTemp
		WHERE [Channel] <> 'CALL'
	) TMP_IQS 
	LEFT JOIN [TemplateThemeItem] TTI (NOLOCK) 
		ON TMP_IQS.[VCC] = TTI.[VCC]
			AND TMP_IQS.[TemplateId] = TTI.[TemplateId]
			AND TMP_IQS.[TemplateThemeItemId] = TTI.Id
	LEFT JOIN [StudyDetail] SD (NOLOCK) 
		ON TMP_IQS.[VCC] = SD.[VCC]
			AND TMP_IQS.[StudyId] = SD.[StudyId]
			AND TTI.[TemplateThemeId] = SD.[TemplateThemeId]
			AND TMP_IQS.[TranscriptionId] = SD.[TranscriptionId]
	INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
		ON TMP_IQS.[VCC] = PAI.[VCC]
			AND PAI.[InteractionType] = TMP_IQS.[Channel]
			AND PAI.[FormattedEndDate] = TMP_IQS.[EndDate]
			AND PAI.[Campaign] = TMP_IQS.[Campaign]
			AND PAI.[ProcessId] = TMP_IQS.ProcessId
			-- AND PAI.[InteractionId] = TMP_IQS.[TranscriptionId]
			AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = TMP_IQS.[TranscriptionId]
	WHERE SD.[TranscriptionId] IS NULL 
		AND TTI.[TemplateThemeId] IS NOT NULL

	
	-- INSERTAMOS LOS REGISTROS CALL A LA TABLA STUDYRESULTSUMMARY
	INSERT INTO [dbo].[StudyResultSummary]
		([VCC]
		,[StudyId]
		, [TemplateId]
		, [TemplateThemeId]
		, [ID]
		, [Description]
		, [Category1]
		, [Category2]
		, [Total]
		, [Duration]
		, [Silence]
		, [OtherDuration]
		, [OtherSilence]
		, [Confidence]
		, [IsMatched]
		, [CreatedDate]
		, [CreatedByUserId]
		, [LastModifiedDate]
		, [LastModifiedByUserId]
		, [TimeStamp]
		)
	SELECT
		A.VCC
		, A.StudyId
		, A.TemplateId
		, B.TemplateThemeId
		, CONVERT(VARCHAR(50), NEWID()) ID
		, D.[Description]
		, D.Category1
		, D.Category2
		, COUNT(A.Total) Total
		, SUM(A.Duration) Duration
		, SUM(A.Silence) Silence
		, SUM(A.OtherDuration) Duration
		, SUM(A.OtherSilence) Silence
		, AVG(A.Confidence) Confidence
		, 1
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, [Total]
			, [Duration]
			, [Silence]
			, [OtherDuration]
			, [OtherSilence]
			, [Confidence]
		FROM #InteractionQueryStudyTemp
		WHERE [Channel] = 'CALL'
	) A
	LEFT JOIN [TemplateThemeItem] B (nolock) ON A.[VCC] = B.[VCC]
		AND A.[TemplateId] = B.[TemplateId]
		AND A.[TemplateThemeItemId] = B.Id
	LEFT JOIN [StudyResultSummary] C (nolock) ON A.[VCC] = C.[VCC]
		AND A.[StudyId] = C.[StudyId]
		AND B.[TemplateThemeId] = C.[TemplateThemeId]
	LEFT JOIN [TemplateTheme] D (nolock) ON A.[VCC] = D.[VCC]
		AND A.[TemplateId] = D.[TemplateId]
		AND B.[TemplateThemeId] = D.[ID]
	INNER JOIN [ProcessAudio] E (nolock) ON A.[VCC] = E.[VCC]
		AND A.ProcessId = E.ProcessId
		AND CONCAT(E.[AudioId],'_',ISNULL(E.[Section], '0'),'_',ISNULL(E.[Part], '0')) = A.[TranscriptionId]
	WHERE C.[TemplateThemeId] is null 
		and B.[TemplateThemeId] is not null
	GROUP BY A.VCC
	, A.StudyId
	, A.TemplateId
	, B.TemplateThemeId
	, D.[Description]
	, D.Category1
	, D.Category2


	-- INSERTAMOS LOS REGISTROS DE OTROS CANALES A LA TABLA STUDYRESULTSUMMARY
	INSERT INTO [dbo].[StudyResultSummary]
		([VCC]
		,[StudyId]
		, [TemplateId]
		, [TemplateThemeId]
		, [ID]
		, [Description]
		, [Category1]
		, [Category2]
		, [Total]
		, [Duration]
		, [Silence]
		, [OtherDuration]
		, [OtherSilence]
		, [Confidence]
		, [IsMatched]
		, [CreatedDate]
		, [CreatedByUserId]
		, [LastModifiedDate]
		, [LastModifiedByUserId]
		, [TimeStamp]
		)
	SELECT
		TMP_IQS.VCC
		, TMP_IQS.StudyId
		, TMP_IQS.TemplateId
		, TTI.TemplateThemeId
		, CONVERT(VARCHAR(50), NEWID()) ID
		, TT.[Description]
		, TT.Category1
		, TT.Category2
		, COUNT(TMP_IQS.Total) Total
		, SUM(TMP_IQS.Duration) Duration
		, SUM(TMP_IQS.Silence) Silence
		, SUM(TMP_IQS.OtherDuration) Duration
		, SUM(TMP_IQS.OtherSilence) Silence
		, AVG(TMP_IQS.Confidence) Confidence
		, 1
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, [Total]
			, [Duration]
			, [Silence]
			, [OtherDuration]
			, [OtherSilence]
			, [Confidence]
			, [Campaign]
			, [EndDate]
			, [Channel]
		FROM #InteractionQueryStudyTemp
		-- FROM TMP_INTERACTION_QUERY_STUDY (NOLOCK)
		WHERE [Channel] <> 'CALL'
	) TMP_IQS 
	LEFT JOIN [TemplateThemeItem] TTI (nolock) 
		ON TMP_IQS.[VCC] = TTI.[VCC]
			AND TMP_IQS.[TemplateId] = TTI.[TemplateId]
			AND TMP_IQS.[TemplateThemeItemId] = TTI.Id
	LEFT JOIN [StudyResultSummary] SRS (nolock) 
		ON TMP_IQS.[VCC] = SRS.[VCC]
			AND TMP_IQS.[StudyId] = SRS.[StudyId]
			AND TTI.[TemplateThemeId] = SRS.[TemplateThemeId]
	LEFT JOIN [TemplateTheme] TT (nolock) 
		ON TMP_IQS.[VCC] = TT.[VCC]
			AND TMP_IQS.[TemplateId] = TT.[TemplateId]
			AND TTI.[TemplateThemeId] = TT.[ID]
	INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
		ON TMP_IQS.[VCC] = PAI.[VCC]
			AND PAI.[InteractionType] = TMP_IQS.[Channel]
			AND PAI.[FormattedEndDate] = TMP_IQS.[EndDate]
			AND PAI.[Campaign] = TMP_IQS.[Campaign]
			AND PAI.[ProcessId] = TMP_IQS.ProcessId
			--AND PAI.[InteractionId] = TMP_IQS.[TranscriptionId]
			AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = TMP_IQS.[TranscriptionId]
	WHERE SRS.[TemplateThemeId] IS NULL 
		AND TTI.[TemplateThemeId] IS NOT NULL 
	GROUP BY TMP_IQS.VCC
	, TMP_IQS.StudyId
	, TMP_IQS.TemplateId
	, TTI.TemplateThemeId
	, TT.[Description]
	, TT.Category1
	, TT.Category2

	--select * from [ProcessAsyncInteraction] (NOLOCK)
	-- ACTUALIZAMOS LA DATA DE AUDIO(SYNCINTERACTION)
	UPDATE A
		SET A.[ValidChar] = TMP_IQS.[ValidChar],
			A.[ValidWords] = TMP_IQS.[ValidWords],
			A.[LastModifiedByUserId] = 'system',
			A.[LastModifiedDate] = GETUTCDATE(),
			A.[TimeStamp] = GETUTCDATE()
		FROM [dbo].[Audio] A
		INNER JOIN [dbo].[#InteractionQueryStudyTemp] TMP_IQS 
			ON CONCAT(A.[ID],'_',ISNULL(A.[Section], '0'),'_',ISNULL(A.[Part], '0')) = TMP_IQS.[TranscriptionId]
			

	-- ACTUALIZAMOS LA DATA DE ASYNCINTERACTION
	UPDATE  AI
		SET AI.[ValidChar] = TMP_IQS.[ValidChar],
			AI.[ValidWords] = TMP_IQS.[ValidWords],
			AI.[LastModifiedByUserId] = 'system',
			AI.[LastModifiedDate] = GETUTCDATE(),
			AI.[TimeStamp] = GETUTCDATE()
		FROM [dbo].[AsyncInteraction] AI
		INNER JOIN [dbo].[#InteractionQueryStudyTemp] TMP_IQS 
			ON TMP_IQS.[VCC] = AI.[VCC]
				AND AI.[Channel] = TMP_IQS.[Channel]
				AND AI.[Folder] = TMP_IQS.[EndDate]
				AND AI.[Campaign] = TMP_IQS.[Campaign]
				--AND AI.[ID] = TMP_IQS.[TranscriptionId]
				AND CONCAT(AI.[Channel], '_', AI.[Campaign], '_', AI.[Folder], '_', REPLACE(AI.[ID], ':', '_')) = TMP_IQS.[TranscriptionId]
				

	DROP TABLE [dbo].[#InteractionQueryStudyTemp]

	SELECT 1 'result'

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
