SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[DeleteAbility] (
	@Instance Varchar(50) = NULL, @ID Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION
			-- ELIMINAMOS LO ITEMS ASOCIADOS A LOS SCORES
			DECLARE RECURRENT_CURSOR CURSOR 
			LOCAL STATIC READ_ONLY FORWARD_ONLY
			FOR 
			-- SELECCIONAMOS LOS VCC EXISTENTES
			SELECT [ID]
				FROM [Score]
				WHERE [Instance] = @Instance
					AND [IdAbility] = @ID 
			
			-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL SCORE ACTUAL QUE ESTAMOS ELIMINANDO
			DECLARE @CURRENT_SCORE_TO_REMOVE VARCHAR(50) = ''

			-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
			OPEN RECURRENT_CURSOR

			FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_SCORE_TO_REMOVE
			WHILE @@FETCH_STATUS = 0
			BEGIN
				-- ELIMINAMOS LOS REGISTROS DE SCORETIPIFICATION
				DELETE [ScoreTipificationItem] 
					WHERE [VCC] = @Instance
						AND [ScoreId] = @CURRENT_SCORE_TO_REMOVE

				-- ELIMINAMOS LOS REGISTROS DE SCORETIPIFICATION
				DELETE [ScoreTipification] 
					WHERE [VCC] = @Instance
						AND [ScoreId] = @CURRENT_SCORE_TO_REMOVE

				-- ELIMINAMOS LOS REGISTROS DE SCORE
				DELETE [Score]
					WHERE [Instance] = @Instance
						AND [IdAbility] = @ID 
						
				FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_SCORE_TO_REMOVE
			END
			CLOSE RECURRENT_CURSOR
			DEALLOCATE RECURRENT_CURSOR

			-- ELIMINAMOS LOS REGISTROS ABILITYQUERY
			DELETE [AbilityQuery] 
				WHERE [VCC] = @Instance 
					AND [AbilityId] = @ID

			-- ELIMINAMOS EL REGISTRO ABILITY
			DELETE [Ability] 
				WHERE [Instance] = @Instance
					AND [ID] = @ID

			DELETE [AbilityScoreCard] 
				WHERE [VCC] = @Instance
					AND [ID] = @ID

			SELECT 1 AS 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
