SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[DeleteEvaluationFormat] (
	@Instance Varchar(50) = NULL, 
	@ID Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION
			-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LA PLANTILLA
			DECLARE @TEMPLATE_ID VARCHAR(50) = NULL

			-- RECUPERAMOS EL TEMPLATE ASOCIADO AL FORMATO
			SELECT @TEMPLATE_ID = [templateId]
				FROM [dbo].[EvaluationFormat] (NOLOCK)
				WHERE [Instance] = @Instance
					AND [ID] = @ID
			
			-- ELIMINAMOS EL REGISTRO DEL FORMATO
			DELETE [dbo].[EvaluationFormat] 
				WHERE [Instance] = @Instance
					AND [ID] = @ID

			-- ELIMINAMOS EL CONTENIDO DEL FORMATO
			EXEC [dbo].[DeleteEvaluationFormatContent] @Instance, @ID, @TEMPLATE_ID

			SELECT 1 AS 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
