SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[DeleteEvaluationFormatContent] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationFormatId VARCHAR(50) = NULL,
	@TemplateId VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION
			-- VERIFICAMOS SI TIENE CONTENIDO EL NOMBRE DE FORMATO
			IF @TemplateId IS NOT NULL AND @TemplateId <> ''
			BEGIN
				-- ELIMINAMOS EL TEMPLATE (SP DeleteTemplate)
				EXEC [dbo].[DeleteTemplate] @VCC, @TemplateId
			END

			-- ELIMINAMOS LAS CAMPAIGNS (REEMPLAZA SP DeleteCampainEvaluationFormat)
			DELETE [dbo].[CampaignEvaluationFormat]
				WHERE [Instance] = @VCC
					AND [IdEvaluationFormat] = @EvaluationFormatId
			
			-- ELIMINAMOS LOS ABILITYEVALUATIONFORMAT (REEMPLAZA SP DeleteAbilityEvaluationFormat)
			DELETE [AbilityEvaluationFormat] 
				WHERE [Instance] = @VCC
					AND [IdEvaluationFormat] = @EvaluationFormatId

			-- ELIMINAMOS LOS SCORETIPIFICATION
			DELETE [dbo].[EvaluationFormatAbilityScoreTipification]
				WHERE [VCC] = @VCC 
					AND [EvaluationFormatId] = @EvaluationFormatId

			-- ELIMINAMOS LOS SCORETIPIFICATIONITEM
			DELETE [dbo].[EvaluationFormatAbilityScoreTipificationItem]
				WHERE [VCC] = @VCC 
					AND [EvaluationFormatId] = @EvaluationFormatId

			-- ELIMINAMOS LOS SCORETIPIFICATIONQUERY
			DELETE [dbo].[EvaluationFormatAbilityScoreTipificationQuery]
				WHERE [VCC] = @VCC 
					AND [EvaluationFormatId] = @EvaluationFormatId

			-- ELIMINAMOS LOS CAMPOS PERSONALIZADOS DEL FORMATO (REEMPLAZA SP DeleteEvaluationFormatCustomFields)
			DELETE FROM [dbo].[EvaluationFormatCustomField] 
				WHERE [VCC] = @VCC 
					AND [EvaluationFormatId] = @EvaluationFormatId

			-- ELIMINAMOS LAS FIRMAS ADJUNTAS DEL FORMATO (REEMPLAZA SP DeleteEvaluationFormatAttachedSignatures)
			DELETE FROM [dbo].[EvaluationFormatAttachedSignature] 
				WHERE [VCC] = @VCC 
					AND [EvaluationFormatId] = @EvaluationFormatId
    
			SELECT 1 AS 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH
    

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
