SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- PARA ELIMINAR UN PLAN DE EVALUACION SE SISTEMA, DEBEMOS ELIMINARLO DE LAS TABLAS EVALUATIONRESULT, 
--  AUDITOREVALUATIONPLAN, INTERACTIONSEVALUATIONPLAN Y EVALUATIONPLAN EN ESE ORDEN
CREATE PROCEDURE [dbo].[DeleteEvaluationPlan] (
	@Instance Varchar(50) = NULL, 
	@IdEvaluationPlan Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA DETERMINAR SI EXISTE EL PLAN DADO O NO
	DECLARE @EVALUATIONPLAN_EXISTS BIT = 0

	-- CONTAMOS CUANTOS PLANES DE EVALUACION EXISTEN CON EL ID Y VCC DADOS
	SELECT @EVALUATIONPLAN_EXISTS = COUNT(EP.[ID]) 
		FROM EvaluationPlan EP 
		WHERE EP.[Instance] = @Instance
			AND EP.[ID] = @IdEvaluationPlan
	
	-- SI EXISTE UN PLAN DE EVALUACION CON LOS PARAMETROS RECIBIDOS, ELIMINAMOS
	--  LOS REGISTROS CORRESPONDIENTES QUE SE ENCUENTRAN EN OTRAS TABLAS
	IF (@EVALUATIONPLAN_EXISTS = 1) 
	BEGIN
		-- ELIMANOS LOS REGISTROS DE RESULTADOS DE LAS EVALUACIONES DEL PLAN
		DELETE FROM EvaluationResult 
		WHERE [Instance] = @Instance
			AND [IdEvaluationPlan] = @IdEvaluationPlan

		-- ELIMINAMOS LOS REGISTROS DE EVALUACION DEL PLAN
		DELETE FROM AuditorEvaluationPlan 
		WHERE [Instance] = @Instance
			AND [IdEvaluationPlan] = @IdEvaluationPlan

		-- ELIMINAMOS LOS REGISTROS DE INTERACCIONES RELACIONADAS AL PLAN
		DELETE FROM InteractionEvaluationPlan
		WHERE [Instance] = @Instance
			AND [IdEvaluationPlan] = @IdEvaluationPlan

		-- ELIMINAMOS EL REGISTROS DEL PLAN DE EVALUACION
		DELETE [EvaluationPlan]
		WHERE [Instance] = @Instance
			AND [ID] = @IdEvaluationPlan
		
		--ELIMINAR DATA HISTORICA
		DELETE FROM [dbo].[HistoricEvaluationFormat] WHERE [VCC] = @Instance AND  [EvaluationPlanId] = @IdEvaluationPlan
		DELETE FROM [dbo].[HistoricGroup] WHERE [VCC] = @Instance AND  [EvaluationPlanId] = @IdEvaluationPlan
		DELETE FROM [dbo].[HistoricSubGroup] WHERE [VCC] = @Instance AND  [EvaluationPlanId] = @IdEvaluationPlan
		DELETE FROM [dbo].[HistoricAbility] WHERE [VCC] = @Instance AND  [EvaluationPlanId] = @IdEvaluationPlan
		DELETE FROM [dbo].[HistoricAbilityEvaluationFormat] WHERE [VCC] = @Instance AND  [EvaluationPlanId] = @IdEvaluationPlan
		DELETE FROM [dbo].[HistoricAbilityQuery] WHERE [VCC] = @Instance AND  [EvaluationPlanId] = @IdEvaluationPlan
		DELETE FROM [dbo].[HistoricAbilityQueryEntity] WHERE [VCC] = @Instance AND  [EvaluationPlanId] = @IdEvaluationPlan
		DELETE FROM [dbo].[HistoricEvaluationFormatCustomField] WHERE [VCC] = @Instance AND  [EvaluationPlanId] = @IdEvaluationPlan
		DELETE FROM [dbo].[HistoricCustomField] WHERE [VCC] = @Instance AND  [EvaluationPlanId] = @IdEvaluationPlan
		DELETE FROM [dbo].[HistoricEvaluationFormatAttachedSignature] WHERE [VCC] = @Instance AND  [EvaluationPlanId] = @IdEvaluationPlan
		DELETE FROM [dbo].[HistoricCustomFieldResult] WHERE [VCC] = @Instance AND  [EvaluationPlanId] = @IdEvaluationPlan
		DELETE FROM [dbo].[HistoricCampaignEvaluationFormat] WHERE [VCC] = @Instance AND  [EvaluationPlanId] = @IdEvaluationPlan

		SELECT 1 AS 'result'

	END 
	ELSE
	BEGIN
		SELECT 0 AS 'result'
	END
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
