SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE [dbo].[DeleteNLU] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL ID DEL NLU
	DECLARE @APP_ID VARCHAR(100) = NULL
	
	-- ASIGNAMOS EL APPID A LA VARIABLE
	SELECT @APP_ID = N.[AppId]
		FROM [dbo].[NLU] N (NOLOCK)
		WHERE N.[VCC] = @VCC 
			AND N.[Name] = @Name

	-- ELIMINAMOS LOS ENTITY DE LA TABLA UTTERANCE-ENTITY
	DELETE UE 
		FROM [dbo].[NLU] N
		INNER JOIN [dbo].[Entity] E 
			ON E.[VCC] = N.[VCC]
				AND E.[AppId] = N.[AppId]
		INNER JOIN [dbo].[Utterance] U 
			ON N.[VCC] = U.[VCC]
				AND U.[AppId] = N.[AppId] 
		INNER JOIN [dbo].[UtteranceEntity] UE 
			ON UE.[VCC] = U.[VCC]
				AND UE.[UtteranceId]= U.[Id]
				AND UE.[EntityName] = E.[Name]
		WHERE N.[AppId] = @APP_ID

    --ELIMINAMOS LOS UNDERLINEDS DE LA TABLA UNDERLINED
    
    	DELETE UL 
		FROM [dbo].[NLU] N
		INNER JOIN [dbo].[Intent] I 
			ON I.[VCC] = N.[VCC]
				AND I.[AppId] = N.[AppId]
		INNER JOIN [dbo].[Utterance] U 
			ON N.[VCC] = U.[VCC]
				AND U.[AppId] = N.[AppId] 
		INNER JOIN [dbo].[Underlined] UL 
			ON UL.[VCC] = U.[VCC]
				AND UL.[UtteranceId]= U.[Id]
		WHERE N.[AppId] = @APP_ID
		
	-- ELIMINAMOS LOS UTTERANCES LA TABLA UTTERANCE
	DELETE FROM [dbo].[Utterance]
		WHERE [VCC] = @VCC
			AND [AppID] = @APP_ID

	-- ELIMINAMOS LOS INTENTS DE LA TABLA INTENT
	DELETE FROM [dbo].[Intent]
		WHERE [VCC] = @VCC
			AND [AppId] = @APP_ID

	-- ELIMINAMOS LOS ENTITY DE LA TABLA ENTITY
	DELETE FROM [dbo].[Entity]
		WHERE [VCC] = @VCC
			AND [AppId] = @APP_ID

	-- ELIMINAMOS EL MODELO DE LA TABLA NLU
	DELETE FROM [dbo].[NLU]
		WHERE [VCC] = @VCC
			AND [AppId] = @APP_ID

	SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
