SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[DeleteProcess] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

			-- VERIFICAMOS SI EXISTE EL PROCESS A ELIMINAR
			IF EXISTS(
				SELECT [Name] 
					FROM [dbo].[Process] (NOLOCK)
					WHERE [VCC] = @VCC 
					AND [Name] = @Name
			)
			BEGIN
				-- ELIMINAMOS DE PROCESSSUMMARY
				DELETE FROM [dbo].[ProcessSummary]
					WHERE [VCC] = @VCC
					AND [ProcessId] = @Name

				-- ELIMINAMOS DE PROCESSAUDIO
				DELETE FROM [dbo].[ProcessAudio]
					WHERE [VCC] = @VCC
					AND [ProcessId] = @Name

				-- ELIMINAMOS DE PROCEESSFILTER
				DELETE FROM [dbo].[ProcessFilter]
					WHERE [VCC] = @VCC
					AND [ProcessId] = @Name

				-- ELIMINAMOS DE PROCESSAUDIOSUMMARY
				DELETE FROM [dbo].[ProcessAudioSummary]
					WHERE [VCC] = @VCC
					AND [ProcessId] = @Name

				-- ELIMINAMOS DE TRANSCRIPTION
				DELETE FROM [dbo].[Transcription]
					WHERE [VCC] = @VCC
					AND [ProcessId] = @Name

				-- ELIMINAMOS DE PROGRESS
				DELETE FROM [dbo].[Progress]
					WHERE [VCC] = @VCC
					AND [ProcessId] = @Name

				-- ELIMINAMOS LA DATA POSIBLE DATA DE UNA PLANTILLA AGENDADA (STUDYRESULTSUMMARYDETAIL)
				DELETE FROM [dbo].[StudyResultSummaryDetail] 
					WHERE [VCC] = @VCC 
						AND [StudyId] IN (
							SELECT S.[Name] 
								FROM [Study] S (NOLOCK) 
								WHERE S.[ProcessId] = @Name
									AND S.[Type] = 'TEMPLATE'
						)

				-- ELIMINAMOS LA DATA POSIBLE DATA DE UNA PLANTILLA AGENDADA (STUDYRESULTSUMMARY)
				DELETE FROM [dbo].[StudyResultSummary]
					WHERE [VCC] = @VCC 
						AND [StudyId] IN (
							SELECT S.[Name] 
								FROM [Study] S (NOLOCK) 
								WHERE S.[ProcessId] = @Name
									AND S.[Type] = 'TEMPLATE'
						)

				-- ELIMINAMOS LA DATA POSIBLE DATA DE UNA PLANTILLA AGENDADA (STUDY)
				DELETE FROM [Study]
					WHERE [ProcessId] = @Name
						AND [Type] = 'TEMPLATE'

				-- ACTUALIZAMOS LOS REGISTROS DE AGENDA
				UPDATE [dbo].[BatchScheduleExecution]
					SET [Status] = 'DISCARDED_BY_DELETED_PROCESS',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [VCC] = @VCC 
						AND [ProcessId] = @NAME

				-- FINALIZAMOS ELIMINANDO DE PROCSS
				DELETE FROM [dbo].[Process]
					WHERE [VCC] = @VCC
					AND [Name] = @Name

				SELECT 1 AS 'result'
			END
			ELSE
			BEGIN
				SELECT 0 AS 'result'
			END

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
