SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[DeleteScoreTipification] (
	@VCC VARCHAR(50) = NULL, 
	@ScoreId VARCHAR(50) = NULL, 
	@ID VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

			-- ELIMINAMOS LA TIPIFICACION
			DELETE [ScoreTipification] 
				WHERE [VCC] = @VCC
					AND [ScoreId] = @ScoreId
					AND [ID] = @ID
					
			-- ELIMINAMOS LOS ITEMS DE LA TIPIFICACION
			DELETE [ScoreTipificationItem] 
				WHERE [VCC] = @VCC 
					AND [ScoreId] = @ScoreId
					AND [TipificationId] = @ID
    
			SELECT 1 AS 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
