SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[DeleteTemplate] (
	@VCC Varchar(50) = NULL, 
	@Name Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON
	
	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION
			DELETE FROM [Template]
				WHERE [VCC] = @VCC
					AND [Name] = @Name
	
			DELETE FROM [TemplateTheme]
				WHERE [VCC] = @VCC
					AND [TemplateId] = @Name

			DELETE FROM [TemplateThemeItem]
				WHERE [VCC] = @VCC
					AND [TemplateId] = @Name
	
			SELECT 1 AS 'result'
		
		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
