SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[EvaluateProcessStatus]
(
	@VCC						VARCHAR(50),
	@ProcessId					VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON
	
	  UPDATE Process
	  SET [Status] = CASE 
		WHEN B.total <= transcription + cancel AND cancel > transcription THEN 'FAILED' 
		WHEN B.total <= transcription + cancel THEN 'COMPLETE' 
		ELSE 'INPROCESS_TRANSCRIPTION' 
		END
	  FROM (
		  SELECT 
			COUNT(1)					total
			,COUNT(B.isCancel)			cancel
			,COUNT(B.IsTranscribed)		transcription 
			,A.ProcessId				processId
			,A.vcc						vcc
		  FROM [ProcessAudio] A (NOLOCK)
		  INNER JOIN Audio B (NOLOCK) ON A.VCC = B.VCC AND A.AudioId =B.ID AND ISNULL(A.Section,0) = ISNULL(B.Section,0) AND ISNULL(A.Part,0) = ISNULL(B.Part,0)
		  WHERE A.VCC = @VCC AND A.ProcessId = @ProcessId
		  GROUP BY A.ProcessId, A.vcc
	  ) B
	  WHERE  B.VCC = [Process].VCC AND B.ProcessId = Process.[Name]

	UPDATE EvaluationPlan
	  set [Status] = 5
	  --SELECT * 
	  FROM EvaluationPlan A (NOLOCK)
	  INNER JOIN Process B (NOLOCK) ON A.Instance = B.Vcc AND A.ProcessId =  B.[Name] AND B.[Status] = 'COMPLETE'
	  WHERE
	  A.Instance = @VCC 
	  AND A.Evaluation_Mode = 'A'
	  AND A.ProcessId = @ProcessId
	  AND A.[Status] < 5

	SELECT 1 AS 'result'

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
