SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE [dbo].[GetAbilityEvaluationFormats] (
	@Instance           Varchar(50) = NULL, 
	@IdEvaluationFormat Varchar(50) = NULL,
	@EvaluationPlanId   VARCHAR(50) = NULL -- DEPRECATED: A ELIMINAR
) AS
BEGIN
	SET NOCOUNT ON

	SELECT DISTINCT AEF.[ID]						'id',
					AEF.[IdEvaluationFormat]		'idEvaluationFormat',
					AEF.[IdAbility]					'idAbility',
					A.[Title]						'titleAbility',
					A.[Detail]						'detailAbility',
					A.[Type]						'abilityType',
					A.[AnalysisType]				'abilityAnalysisType',
					-- A.[CalificationType]			'abilityCalificationType',
					AEF.[IdGroup]					'idGroup',
					G.[Description]                 'descriptionGroup',
					AEF.[IdSubGroup]				'idSubGroup',
					SG.[Description]                'descriptionSubGroup',
					AEF.[Penalizes]					'penalizes',
					AEF.[Score]						'score',
					AEF.[Order]						'order',
					A.[NotApply]					'acceptNotApplies',
					A.[Distribute]					'distribute',
					A.[AcceptComments]				'acceptComments',
					A.[Detail]						'descriptionAbility',
					AEF.[Conditional]				'conditional',
					A.[Query]						'abilityQuery',
					A.QueryName						'query',
					A.[IsNegative]                  'isNegative'
		FROM [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
		INNER JOIN [dbo].[Group] G (NOLOCK)
			ON G.[Instance] = AEF.[Instance]
				AND G.[ID] = AEF.[IdGroup]
		INNER JOIN [dbo].[SubGroup] SG (NOLOCK)
			ON SG.[Instance] = AEF.[Instance]
				AND SG.[ID] = AEF.[IdSubGroup]
		INNER JOIN [dbo].[Ability] A (NOLOCK)
			ON A.[Instance] = AEF.[Instance]
				AND A.[ID] = AEF.[IdAbility]
		WHERE AEF.[Instance] = @Instance
			AND AEF.[IdEvaluationFormat]= @IdEvaluationFormat
		ORDER BY [Order] ASC


	
	-- CONSULTAMOS LOS SCORES RELACIONADOS AL FORMATO
	SELECT S.[Id]									'id',
			S.[IdAbility]							'abilityId',
			S.[Description]							'description',
			S.[Value]								'value'
		FROM [dbo].[Ability] A (NOLOCK)
		INNER JOIN [dbo].[Score] S (NOLOCK)
			ON S.[Instance] = A.[Instance]
				AND S.[IdAbility] = A.[ID]
		INNER JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK) 
			ON AEF.[Instance] = A.[Instance]
				AND AEF.[IdAbility] = A.[ID]
		WHERE AEF.[Instance] = @Instance
			AND AEF.[IdEvaluationFormat] = @IdEvaluationFormat
		ORDER BY S.[Value] DESC



	-- CONSULTAMOS LAS TIPIFICACIONES DE LAS HABILIDADES RELACIONADAS AL FORMATO
	SELECT CAST(EFAST.[ScoreId] AS INT)				'scoreId',
			EFAST.[ID]								'id',
			EFAST.[Description]						'description',
			EFAST.[Detail]							'detail',
			EFAST.[Order]							'order'
		FROM [dbo].[EvaluationFormatAbilityScoreTipification] EFAST (NOLOCK)
		WHERE EFAST.[VCC] = @Instance
			AND EFAST.[EvaluationFormatId] = @IdEvaluationFormat
		ORDER BY EFAST.[Order] ASC



	-- CONSULTAMOS LAS QUERY DE TIPIFICACION DE LAS HABILIDADES RELACIONADAS AL FORMATO
	SELECT CAST(EFASTQ.[ScoreId] AS INT)			'scoreId',
			EFASTQ.[TipificationId]					'tipificationId',
			EFASTQ.[QueryId]						'queryId',
			EFASTQ.[QueryContent]					'queryContent',
			EFASTQ.[AcceptancePercentage]			'acceptancePercentage',
			EFASTQ.[AcceptancePercentage] * 100		'acceptanceInteger'
		FROM [dbo].[EvaluationFormatAbilityScoreTipificationQuery] EFASTQ (NOLOCK)
		WHERE EFASTQ.[VCC] = @Instance
			AND EFASTQ.[EvaluationFormatId] = @IdEvaluationFormat	



	-- CONSULTAMOS LOS ITEMS DE TIPIFICACIONES DE LAS HABILIDADES RELACIONADAS AL FORMATO
	SELECT CAST(EFASTI.[ScoreId] AS INT)			'scoreId',
			EFASTI.[TipificationId]					'tipificationId',
			EFASTI.[ID]								'id',
			EFASTI.[SecondLevelItemId]				'secondLevelItemId',
			EFASTI.[Description]					'description',
			EFASTI.[Order]							'order'
		FROM [dbo].[EvaluationFormatAbilityScoreTipificationItem] EFASTI (NOLOCK)
		WHERE EFASTI.[VCC] = @Instance
			AND EFASTI.[EvaluationFormatId] = @IdEvaluationFormat
		ORDER BY EFASTI.[Order] ASC
	


	/*
	DECLARE @QUERY VARCHAR(MAX) = ''

	SET @QUERY += '	SELECT DISTINCT
					AEF.[ID]							''id'',
					AEF.[IdEvaluationFormat]		''idEvaluationFormat'',
					AEF.[IdAbility]					''idAbility'',
					A.[Title]						''titleAbility'',
					A.[Detail]						''detailAbility'',
					A.[Type]						''abilityType'',
					A.[AnalysisType]				''abilityAnalysisType'',
					AEF.[IdGroup]					''idGroup'',
					G.[Description]                 ''descriptionGroup'',
					AEF.[IdSubGroup]				''idSubGroup'',
					SG.[Description]                ''descriptionSubGroup'',
					AEF.[Penalizes]					''penalizes'',
					AEF.[Score]						''score'',
					AEF.[Order]						''order'',
					A.[NotApply]					''acceptNotApplies'',
					A.[Distribute]					''distribute'',
					A.[AcceptComments]				''acceptComments'',
					A.[Detail]						''descriptionAbility'',
					AEF.[Conditional]				''conditional'',
					A.[Query]						''abilityQuery'',
					A.QueryName						''query'',
					A.[IsNegative]                  ''isNegative'''

	 IF (@EvaluationPlanId IS NOT NULL AND @EvaluationPlanId <> '')
	 BEGIN 

			SET @QUERY +='	FROM [dbo].[HistoricAbilityEvaluationFormat] AEF (NOLOCK)
				INNER JOIN [dbo].[HistoricGroup] G (NOLOCK)
					ON G.[VCC] = AEF.[VCC]
						AND G.[ID] = AEF.[IdGroup] AND G.[EvaluationPlanId] = AEF.[EvaluationPlanId]
				INNER JOIN [dbo].[HistoricSubGroup] SG (NOLOCK)
					ON SG.[VCC] = AEF.[VCC]
						AND SG.[ID] = AEF.[IdSubGroup]
						AND SG.[EvaluationPlanId] = AEF.[EvaluationPlanId]
				INNER JOIN [dbo].[HistoricAbility] A (NOLOCK)
					ON A.[VCC] = AEF.[VCC]
						AND A.[ID] = AEF.[IdAbility]
						AND A.[EvaluationPlanId] = AEF.[EvaluationPlanId]
				WHERE AEF.[VCC] = '''+@Instance+'''
					AND AEF.[IdEvaluationFormat]= '''+@IdEvaluationFormat+'''
				    AND AEF.[EvaluationPlanId] = '''+@EvaluationPlanId+'''
				ORDER BY [Order] ASC'
	
	 END
	 ELSE
	 BEGIN 

		   SET @QUERY += '	FROM [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
				INNER JOIN [dbo].[Group] G (NOLOCK)
					ON G.[Instance] = AEF.[Instance]
						AND G.[ID] = AEF.[IdGroup]
				INNER JOIN [dbo].[SubGroup] SG (NOLOCK)
					ON SG.[Instance] = AEF.[Instance]
						AND SG.[ID] = AEF.[IdSubGroup]
				INNER JOIN [dbo].[Ability] A (NOLOCK)
					ON A.[Instance] = AEF.[Instance]
						AND A.[ID] = AEF.[IdAbility]
				WHERE AEF.[Instance] = '''+ @Instance+'''
					AND AEF.[IdEvaluationFormat]= '''+@IdEvaluationFormat+'''
				ORDER BY [Order] ASC'
			
	END

	EXEC(@QUERY)
	*/
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
