SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- ESTE SP RETORNA UN RESUMEN DE LA BUSQUEDA DE INTERACCIONES DE ALLEGRO PARA INDETIFICAR LOS YA TRANSCRITOS O INPROCESS SEGUN LOS FILTROS RECIBIDOS 
-- FUNCIONA IGUAL QUE LA FUNCION EN KNEX
CREATE PROCEDURE [dbo].[GetAllegroBillingInteractions] (
   	@VCC VARCHAR(50) = NULL,
	@IP VARCHAR(50), 
	@Type INT,
	@SecondsPerRequest DECIMAL(18, 5),
   	@StartDate DATETIME = '1980-01-01T00:00:00',
    @EndDate DATETIME = '2050-01-01T23:59:59',
	@Campaigns VARCHAR(MAX) = '',
 	@Agents VARCHAR(MAX) = '',
   	@Origins VARCHAR(100) = NULL,
	@StartHour VARCHAR(50) = NULL,
	@EndHour VARCHAR(50) = NULL,
	@MinDuration INT = 0,
    @MaxDuration INT = 100000,
    @Results VARCHAR(MAX) = NULL,
	@Formats VARCHAR(50) = NULL
)
AS 
BEGIN 
	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59'

	-- DECLARAMOASUN CADENA PARA EL QUERY FINAL
	DECLARE @SQL_SELECT_0 VARCHAR(MAX) = ''
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_FILTER VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
	
	-- DECLARAMOS VARIABLES PARA NOS NOMBRES DE LAS TABLAS
	DECLARE @INTERACTION_DETAIL_TABLE NVARCHAR(100)
	DECLARE @INTERACTION_ACTOR_DETAIL_TABLE NVARCHAR(100)
	DECLARE @INTERACTION_MULTIMEDIA_PARTS_TABLE NVARCHAR(100)
	DECLARE @CAMPAIGN_GOAL_RESULT_MANAGEMENT_TABLE NVARCHAR(100)

	-- SETTEAMOS LOS VALORES DE DURACION MINIMA Y MAXIMA A UNO VALIDO
	IF @MinDuration = @MaxDuration AND @MaxDuration = 0 SET @MaxDuration = 100000
	IF @MinDuration IS NULL SET @MinDuration = 0
	IF @MaxDuration IS NULL SET @MaxDuration = 100000

	-- EL PARAMETRO TYPE DEFINE SI LA BD ALLEGRO SE ENCUENTRA LOCAL O REMOTO
	IF (@Type = 0)  
	BEGIN  
		SET @INTERACTION_DETAIL_TABLE = '[' + @Ip + ']' + '.HistoricalData.dbo.[InteractionDetail]'
		SET @INTERACTION_ACTOR_DETAIL_TABLE = '[' + @Ip + ']' + '.HistoricalData.dbo.[InteractionActorDetail]'
		SET @INTERACTION_MULTIMEDIA_PARTS_TABLE = '[' + @Ip + ']' + '.HistoricalData.dbo.[InteractionMultimediaParts]'
		SET @CAMPAIGN_GOAL_RESULT_MANAGEMENT_TABLE = '[' + @Ip + ']' + '.mmprodat.dbo.[CampaignGoalResultManagement]'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @INTERACTION_DETAIL_TABLE = 'HistoricalData.dbo.[InteractionDetail]';
		SET @INTERACTION_ACTOR_DETAIL_TABLE = 'HistoricalData.dbo.[InteractionActorDetail]'
		SET @INTERACTION_MULTIMEDIA_PARTS_TABLE = 'HistoricalData.dbo.[InteractionMultimediaParts]';
		SET @CAMPAIGN_GOAL_RESULT_MANAGEMENT_TABLE = 'mmprodat.dbo.[CampaignGoalResultManagement]';
	END  

	-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
	SET @SQL_SELECT_1 += '
		SELECT '

	SET @SQL_SELECT_1 += '
				ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)			''ID'',
				ID.[Id]																									''InteractionId'',
				A.[IsProcess],
				A.[IsCancel],
				A.[IsTranscribed],
				A.[TotalPhrases],
				ID.[AttentionTime],
				RN = ROW_NUMBER() OVER(PARTITION BY (ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)) ORDER BY ID.[Id])
			'
				
	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += '
			FROM ' + @INTERACTION_MULTIMEDIA_PARTS_TABLE + ' IMP (NOLOCK)
			LEFT JOIN ' + @INTERACTION_DETAIL_TABLE + ' ID (NOLOCK) 
				ON ID.[Id] = IMP.[Id]
			LEFT JOIN ' + @INTERACTION_ACTOR_DETAIL_TABLE + ' IAD (NOLOCK) 
				ON IAD.[Id] = ID.[id]
			LEFT JOIN (
				SELECT VCC, CampaignID, [Order], [Code], 
								[Description], Category1, Category2, Category3 
					FROM ' + @CAMPAIGN_GOAL_RESULT_MANAGEMENT_TABLE + ' (NOLOCK)
					WHERE VCC = ''' + @VCC + '''
			) CGRM  
				ON CGRM.VCC = ID.VirtualCC 
					AND CGRM.CampaignId = ID.Campaign 
					AND CGRM.[Description] = ID.ManagementResult
			LEFT JOIN [dbo].[Audio] A (NOLOCK) 
				ON A.[ID] = ID.[Id]
					AND A.[Section] = IMP.[Section]
					AND A.[Part] = IMP.[Part] 
			'

	-- ARMAMOS LA PARTE DE FILTROS
	SET @SQL_FILTER += '
			WHERE ID.[VirtualCC] = ''' + @VCC + '''
				AND ID.[Id] IS NOT NULL 
				AND ID.[EndDate] BETWEEN ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + ''' AND ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + ''' 
				AND ID.[AttentionTime] BETWEEN ' + (SELECT CONVERT(VARCHAR(10), @MinDuration)) + ' AND ' + (SELECT CONVERT(VARCHAR(10), @MaxDuration)) + ' 
				'
	
	-- CONTINUAMOS CON LOS DEMAS FILTROS RECIBIDOS
	IF (@Campaigns IS NOT NULL AND @Campaigns != '') SET @SQL_FILTER += 'AND ID.[Campaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaigns + ''','','')) '
	IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND IAD.[Actor] IN (SELECT Value FROM [dbo].[split](''' + @Agents + ''','','')) '
	IF (@Origins IS NOT NULL AND @Origins != '') SET @SQL_FILTER += 'AND ID.[Direction] IN (SELECT Value FROM [dbo].[split](''' + @Origins + ''','','')) '
	IF (@Results IS NOT NULL AND @Results != '') 
		/*SET @SQL_FILTER += 'AND (
								(ID.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @Results + ''','','')))
								OR 
								() 
							) '*/
		SET @SQL_FILTER += 'AND (
									(CONCAT(ID.Campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')) IN (SELECT Value FROM [dbo].[split](''' + @Results + ''','','')))
									OR
									(ID.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @Results + ''','',''))) 
								) '
	IF (@Formats IS NOT NULL AND @Formats != '') SET @SQL_FILTER += 'AND IMP.[Format] IN (SELECT Value FROM [dbo].[split](''' + @Formats + ''','','')) ';
	
	-- PARA EL CASO EN QUE HORA DE INICIO Y FIN NO SEAN NULL
	IF @StartHour IS NOT NULL AND @EndHour IS NOT NULL
	BEGIN
		IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) 
			SET @SQL_FILTER += 'AND CAST(ID.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' '
		IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) 
			SET @SQL_FILTER += 'AND CAST(ID.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' '
	END
	-- PARA EL CASO EN QUE HORA DE INICIO NO SEA NULL Y FIN SEA NULL
	ELSE IF @StartHour IS NOT NULL AND @EndHour IS NULL
	BEGIN
		SET @SQL_FILTER += 'AND CAST(ID.[EndDate] AS TIME) > ''' + @StartHour + ''' '
	END
	-- PARA EL CASO EN QUE HORA DE INICIO SEA NULL Y FIN NO SEA NULL
	ELSE IF @StartHour IS NULL AND @EndHour IS NOT NULL
	BEGIN
		SET @SQL_FILTER += 'AND CAST(ID.[EndDate] AS TIME) < ''' + @EndHour + ''' '
	END
	
	-- UNIMOS LAS PARTES DEL QUERY
	SET @SQL_SELECT_1 += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA

	-- VERIFICAMOS SI EXISTE LA TABLA TEMPORAL #TMP_HD_INTERACTIONS
	IF OBJECT_ID('TEMPDB..#TMP_HD_BILLING_INTERACTIONS') IS NULL
	BEGIN
		-- CREAMOS UNA TABLA TEMPORAL PARA INSERTAR LOS REGISTROS DE LA HDI6
		CREATE TABLE #TMP_HD_BILLING_INTERACTIONS
		(
			[ID] VARCHAR(150),
			[InteractionId] VARCHAR(100),
			[IsProcess] BIT,
			[IsCancel] BIT,
			[IsTranscribed] BIT,
			[TotalPhrases] DECIMAL(18, 5),
			[AttentionTime] DECIMAL(18, 5),
			RN INT
		)
	END

	-- EJECUTAMOS EL QUERY Y DEPOSITAMOS EL RESULTADO EN UNA TABLA TEMPORAL
	INSERT INTO #TMP_HD_BILLING_INTERACTIONS
		-- EJECUTAMOS LA CONSULTA
		EXEC (@SQL_SELECT_1)

	-- select * from #TMP_HD_BILLING_INTERACTIONS
		
	-- HACEMOS EL SELECT A LA TABLA TEMPORAL
	SELECT SUM(CASE WHEN A.[IsTranscribed] = 1 THEN 1 ELSE 0 END)									'alreadyTranscribedAudio',
			SUM(CASE WHEN A.[IsTranscribed] = 1 THEN A.[AttentionTime] ELSE 0 END)					'alreadyTranscribedDurationTime',
			SUM(CASE WHEN (A.[IsProcess] = 1 
							AND A.[IsTranscribed] IS NULL 
							AND A.[IsCancel] IS NULL) 
						THEN 1 ELSE 0 END)															'inProcessAudio',
			SUM(CASE WHEN (A.[IsProcess] = 1 
							AND A.[IsTranscribed] IS NULL 
							AND A.[IsCancel] IS NULL) 
						THEN A.[AttentionTime] ELSE 0 END)											'inProcessDurationTime',
			SUM(CASE WHEN (A.[IsProcess] IS NULL 
							OR (A.[IsProcess] = 1 
								AND A.[IsCancel] = 1)) 
						THEN 1 ELSE 0 END)															'notTranscribedAudio',
			SUM(CASE WHEN (A.[IsProcess] IS NULL 
							OR (A.[IsProcess] = 1 
								AND A.[IsCancel] = 1)) 
						THEN A.[AttentionTime] ELSE 0 END)											'notTranscribedDurationTime',
			SUM(CASE WHEN A.[IsTranscribed] = 1 
							AND A.[TotalPhrases] IS NOT NULL
						THEN A.[TotalPhrases] ELSE 0 END)											'totalPhrases',
			SUM(CASE WHEN (A.[IsProcess] IS NULL 
							OR (A.[IsProcess] = 1 
								AND A.[IsCancel] = 1)
							OR (A.[TotalPhrases] IS NULL)) 
						THEN (A.[AttentionTime] / @SecondsPerRequest) ELSE 0 END)					'totalRawPhrases',
			SUM(A.[AttentionTime] / @SecondsPerRequest)												'averageModelRequest' 
		FROM #TMP_HD_BILLING_INTERACTIONS A
		WHERE A.RN = 1

	-- ELIMINAMOS LA TABLA TEMPORARL
	DROP TABLE #TMP_HD_BILLING_INTERACTIONS

	-- EJECUTAMOS LA CONSULTA
	-- EXEC (@SQL_SELECT_1)

END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
