SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetAllegroSupervisor]
(
	@IP				VARCHAR(50),
	@VCC			VARCHAR(50),
	@UserId			VARCHAR(50),
	@Type			BIT
)
AS
BEGIN
	-- ESTE SP RETORNA LA LISTA DE SUPERVISORES DE UN VCC DE TIPO ALLEGRO/OCC CON SUS WORKGROUPS DE AGENTES
	
	-- DECLARAMOS VARIABLES PARA ARMAR LA CONSULTA
	DECLARE @VCC_TYPE VARCHAR(25) = NULL
	DECLARE @SQL VARCHAR(MAX) = NULL
	DECLARE @TABLE_MMPRODAT VARCHAR(100) = NULL

	-- INDETIFICAMOS EL TIPO DE VCC
	SELECT @VCC_TYPE = V.[Type] 
		FROM [dbo].[VCC] V (NOLOCK) 
		WHERE V.[VCC] = @VCC

	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF @Type = 0
	BEGIN  
		SET @TABLE_MMPRODAT = '[' + @Ip + ']' + '.[MMProDat].[dbo].'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @TABLE_MMPRODAT = '[MMProDat].[dbo].'
	END
	
	--
	IF @VCC_TYPE = 'ALLEGRO'
	BEGIN
		-- ARMAMOS LA CONSULTA PRINCIPAL
		/*
		SET @SQL = '
			SELECT DISTINCT U.[VCC]					''vcc'',
							U.[Id]					''userId''
				FROM ' + @TABLE_MMPRODAT + '[SupervisorWorkgroup] SWG (NOLOCK)
				INNER JOIN ' + @TABLE_MMPRODAT + '[User] U (NOLOCK)
					ON U.[VCC] = SWG.[VCC]
						AND U.[Id] = SWG.[SupervisorId]
				WHERE SWG.[VCC] = ''' + @VCC + ''' '
		*/
		SET @SQL = '
			SELECT U.[VCC]					''vcc'',
					U.[Id]					''userId''
				FROM ' + @TABLE_MMPRODAT + '[User] U (NOLOCK)
				LEFT JOIN ' + @TABLE_MMPRODAT + '[SupervisorWorkgroup] SWG (NOLOCK)
					ON SWG.[VCC] = U.[VCC] 
						AND SWG.[SupervisorId] = U.[Id] 
				WHERE U.[VCC] = ''' + @VCC + ''' 
					AND U.[Id] = ''' + @UserId + '''
					AND U.[UserGroup] = ''supervisor'' '
	END
	ELSE IF @VCC_TYPE = 'OCC'
	BEGIN
		SET @SQL = '
			SELECT DISTINCT U.[VCC]					''vcc'',
							U.[Id]					''userId''
				FROM ' + @TABLE_MMPRODAT + '[User] U (NOLOCK) 
				INNER JOIN ' + @TABLE_MMPRODAT + '[GroupApplication] GA (NOLOCK)
					ON GA.[VCC] = U.[VCC]
						AND GA.[GroupId] = U.[UserGroup] 
				LEFT JOIN ' + @TABLE_MMPRODAT + '[UserCampaign] UC (NOLOCK) 
					ON UC.[VCC] = UC.[VCC]
						AND UC.[UserId] = U.[Id]
				LEFT JOIN ' + @TABLE_MMPRODAT + '[SupervisorWorkgroup] SW (NOLOCK)
					ON SW.[VCC] = U.[VCC]
						AND SW.[SupervisorId] = U.[Id]
						AND SW.[CampaignId] = UC.[CampaignId]
				WHERE GA.[VCC] = ''' + @VCC + '''
					AND GA.[ApplicationId] = ''supervisor''
					AND U.[Id] = ''' + @UserId + '''
				ORDER BY U.[Id] ASC, UC.[CampaignId] ASC 
		'
	END
	
	-- EJECUTAMOS LA CONSULTA
	EXEC(@SQL)
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
