SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE [dbo].[GetAuditors] (
	@Instance Varchar(50) = NULL, @SearchCriteria Varchar(50) = NULL, @SearchExpression Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
 	SELECT T.ID								'id',
			U.lastname + ' ' + U.Firstname	'name',
			U.Firstname						'firstname',
			U.lastname						'lastname',
			U.email							'email',
			U.[IsLocalSupervisor]			'isLocalSupervisor',
			U.[IsExternalSupervisor]		'isExternalSupervisor',
			U.[IsExternalAgent]				'isExternalAgent',
			T.CreatedDate					'createdDate',
			T.CreatedByUserId				'createdByUserId',
			T.LastModifiedDate				'lastModifiedDate',
			T.LastModifiedByUserId			'lastModifiedByUserId'
		FROM [dbo].[Auditor] T (NOLOCK)
		INNER JOIN [dbo].[User] U (NOLOCK)
			ON U.[VCC] = T.[Instance]
				AND U.[ID] = T.[ID]
		WHERE T.Instance = @Instance
			AND ISNULL(t.ID, '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
 	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
