SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetBatchScheduledTemplateResults]
(
	@VCC					VARCHAR(50) = NULL,
	@BatchScheduledIds		VARCHAR(MAX) = NULL,
	@StartDate				DATETIME = NULL, -- FILTRO PARA LOS RESULATDOS RECIENTES
	@EndDate				DATETIME = NULL -- FILTRO PARA LOS RESULATDOS RECIENTES
)
AS
BEGIN
	SET NOCOUNT ON

	--DECLARE @VCC VARCHAR(50) = NULL, @BatchScheduleId VARCHAR(50) = NULL
	--SET @VCC = 'vccocc'
	--SET @BatchScheduleId = '20211230_niveles'

	-- OBTENEMOS LOS RESULTADOS RELACIONADOS CON LA AGENDA
	SELECT SRD.[VCC]								'vcc',
			S.[BatchScheduleId]						'batchScheduleId',
			--SRD.[StudyId]							'studyId',
			HTT.[TemplateId]						'templateId',
			SRD.[TemplateThemeId]					'templateThemeId',
			HTT.[Category1]							'category1',
			HTT.[Category2]							'category2',
			HTT.[Description]						'description',
			SRD.[TemplateThemeItemId]				'templateThemeItemId',
			SRD.[TranscriptionId]					'transcriptionId',
			COUNT(*)								'ocurrencies',
			COUNT(
				CASE WHEN SRD.[CreatedDate] >= @StartDate THEN 1 ELSE NULL END
			)										'latestOcurrencies'
		FROM [dbo].[StudyResultSummaryDetail] SRD (NOLOCK)
		INNER JOIN [dbo].[Study] S (nolock)
			ON S.[VCC] = SRD.[VCC]
				AND S.[Name] = SRD.[StudyId]
		INNER JOIN [dbo].[HistoricTemplateTheme] HTT (NOLOCK)
			ON HTT.[VCC] = SRD.[VCC]
				AND HTT.[StudyId] = SRD.[StudyId]
				AND HTT.[ID] = SRD.[TemplateThemeId]
		WHERE S.[VCC] = @VCC
			AND SRD.[CreatedDate] BETWEEN @StartDate AND @EndDate
			AND (
				(
					@BatchScheduledIds <> ''
					AND
					S.[BatchScheduleId] IN (SELECT VALUE FROM [dbo].[split](@BatchScheduledIds, ','))
				)
				OR 
				(
					@BatchScheduledIds = ''
					AND 
					S.[BatchScheduleId] IS NOT NULL
				)
			)
		GROUP BY SRD.[VCC],
					S.[BatchScheduleId],
					--SRD.[StudyId],
					HTT.[TemplateId],
					SRD.[TemplateThemeId],
					HTT.[Category1],
					HTT.[Category2],
					HTT.[Description],
					SRD.[TemplateThemeItemId],
					SRD.[TranscriptionId]
	
	/*
	-- OBTENEMOS LOS RESULTADOS RECIENTES
	SELECT SRD.[VCC]								'vcc',
			S.[BatchScheduleId]						'batchScheduleId',
			SRD.[StudyId]							'studyId',
			HTT.[TemplateId]						'templateId',
			SRD.[TemplateThemeId]					'templateThemeId',
			HTT.[Category1]							'category1',
			HTT.[Category2]							'category2',
			HTT.[Description]						'description',
			SRD.[TemplateThemeItemId]				'templateThemeItemId',
			SRD.[TranscriptionId]					'transcriptionId',
			SRD.[CreatedDate]						'createdDate'
		FROM [dbo].[StudyResultSummaryDetail] SRD (NOLOCK)
		INNER JOIN [dbo].[Study] S (nolock)
			ON S.[VCC] = SRD.[VCC]
				AND S.[Name] = SRD.[StudyId]
		INNER JOIN [dbo].[HistoricTemplateTheme] HTT (NOLOCK)
			ON HTT.[VCC] = SRD.[VCC]
				AND HTT.[StudyId] = SRD.[StudyId]
				AND HTT.[ID] = SRD.[TemplateThemeId]
		WHERE S.[VCC] = @VCC
			AND (
				(
					@BatchScheduleId IS NOT NULL
					AND
					S.[BatchScheduleId] = @BatchScheduleId 
				)
				OR 
				(
					@BatchScheduleId IS NULL
					AND 
					S.[BatchScheduleId] IS NOT NULL
				)
			)
			AND SRD.[CreatedDate] >= @StartDate
	*/

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
