SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetDictionaries] (
	@VCC VARCHAR(50) = NULL, 
	@SearchCriteria VARCHAR(50) = NULL, 
	@SearchExpression VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT [Name]					'name',
			[Description]			'description',
			[Language]				'language',
			[CreatedDate]			'createdDate',
			[CreatedByUserId]		'createdByUserId',
			[LastModifiedDate]		'lastModifiedDate',
			[LastModifiedByUserId]	'lastModifiedByUserId'
		FROM [dbo].[Dictionary] (NOLOCK)
		WHERE [VCC] = @VCC
			AND ISNULL([Name], '') LIKE CASE WHEN @SearchCriteria = 'name' THEN '%' + @SearchExpression + '%' ELSE '%' END
			AND ISNULL([Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
