SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetEvaluationFormat] (
	@Instance         Varchar(50) = NULL,
	@ID               Varchar(50) = NULL,
	@EvaluationPlanId VARCHAR(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	DECLARE @QUERY VARCHAR(MAX) = ''
	
	SET @QUERY = 'SELECT
			[ID]									''id'',
			[Description]							''description'',
			[EnvironmentType]						''environmentType'',
			[Type]									''type'',
			[MinQualificationAcceptable]			''minQualificationAcceptable'',
			[MinAutomaticQualification]				''minAutomaticQualification'',
			[ManagementFormURL]						''managementFormURL'',
			[Enabled]								''enabled'',
			[templateId]							''templateId'''

	IF(@EvaluationPlanId IS NOT NULL AND @EvaluationPlanId <> '')
	BEGIN
	   SET @QUERY += ' FROM [HistoricEvaluationFormat] (NOLOCK)
	                   WHERE [VCC] = '''+@Instance+''' AND [ID] = '''+@ID+''' AND [EvaluationPlanId] = '''+@EvaluationPlanId+''''
	END
    ELSE
    BEGIN 
         SET @QUERY += ', [CreatedDate]							''createdDate'',
			[CreatedByUserId]						''createdByUserId'',
			[LastModifiedDate]						''lastModifiedDate'',
			[LastModifiedByUserId]					''lastModifiedByUserId''
		    FROM [EvaluationFormat] (NOLOCK)
		    WHERE [Instance] = '''+@Instance+''' AND [ID] = ''' +@ID+''''
   END

    EXEC(@QUERY)
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
