SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetEvaluationFormatQualificationAverage] (
	@Instance Varchar(50) = NULL,
	@IdEvaluationFormat Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		EREFQS.EvaluationResultEvaluationFormatQualificationSum/EREFQ.EvaluationResultEvaluationFormatQuantity EvaluationFormatQualificationAverage
	FROM
		(
			-- EvaluationResultEvaluationFormatQualificationSum
			SELECT
				SUM([QualificationSum]) EvaluationResultEvaluationFormatQualificationSum
			FROM
				(
					SELECT
						SUM([Qualification]) QualificationSum
					FROM
						EvaluationResult
					WHERE
						[Instance] = @Instance
						AND [IdEvaluationFormat]= @IdEvaluationFormat
					GROUP BY
						[Instance],
						[IdEvaluationPlan],
						[IdAuditor],
						[IdAgent],
						[IdInteraction]
				) EvaluationResultEvaluationFormat
		) EREFQS,
		(
			-- EvaluationResultEvaluationFormatQuantity
			SELECT
				COUNT(*) EvaluationResultEvaluationFormatQuantity
			FROM
				(
					SELECT
						[IdEvaluationFormat]
					FROM
						EvaluationResult
					WHERE
						[Instance] = @Instance
						AND [IdEvaluationFormat]= @IdEvaluationFormat
					GROUP BY
						[Instance],
						[IdEvaluationPlan],
						[IdAuditor],
						[IdAgent],
						[IdInteraction],
						[IdEvaluationFormat]
				) EvaluationResultEvaluationFormat
		) EREFQ

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
