SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetEvaluationFormatsFromHistoricEvaluationPlans] (
	@VCC VARCHAR(50)
	)
AS
BEGIN
	SET NOCOUNT ON

 	SELECT DISTINCT 
    [ID]          'id',
	[Description] 'description' 

	FROM [dbo].[EvaluationResult] ER (NOLOCK)
    JOIN [dbo].[HistoricEvaluationFormat] EF (NOLOCK)
    ON ER.IdEvaluationFormat = EF.ID 
	AND ER.Instance = EF.VCC
	JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
	ON AEP.IdEvaluationPlan = ER.IdEvaluationPlan
	AND AEP.Instance = ER.Instance
	WHERE EF.VCC =  @VCC AND AEP.Completed = 1

 	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
