SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetEvaluationPlanAbilities] (
	@VCC VARCHAR(50) = NULL, 
	@EvaluationPlanId VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT DISTINCT
	        HA.ID								'id',
			HA.Title							'title',
			HA.Detail							'detail',
			HA.[Type]							'type',
			HA.[CalificationType]				'calificationType',
			HA.[AnalysisType]					'analysisType',
			HA.[Binary]							'binary',
			HA.[NotApply]						'acceptNotApply',
			HA.[AcceptComments]					'acceptComments',
			HA.[Distribute]						'distributes',
			HA.[Enabled]						'enabled',
			HA.[Query]							'query',
			HA.[Queryname]						'queryName',
			HA.[IsNegative]						'isNegative', 
			N.[Culture]							'culture'
		FROM [dbo].[HistoricAbility] HA (NOLOCK)
		LEFT JOIN [dbo].[NLU] N (NOLOCK)
			ON N.[VCC] = HA.[VCC]
				AND N.[Name] = SUBSTRING(HA.[Query], 0, CHARINDEX('|', HA.[Query]))
		WHERE HA.[VCC] = @VCC
			AND HA.[EvaluationPlanId] = @EvaluationPlanId
		ORDER BY HA.[Title]
		
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
