SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetEvaluationPlanAbilitiesQueries] (
	@VCC              VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(50) = NULL
) 
AS
BEGIN
	SET NOCOUNT ON
    
    SELECT DISTINCT HAQ.[ID]											'id',
					HAQ.[AbilityId]										'abilityId',
					HAQ.[QueryId]										'queryId',
					HAQ.[QueryContent]									'queryContent',
					HAQ.[AcceptancePercentage]							'acceptancePercentage',
					ISNULL(HAQ.[AcceptancePercentage], 0) * 100			'acceptanceInteger',
					HAQ.[Order]										    'order' 
		FROM [dbo].[HistoricAbilityQuery] HAQ (NOLOCK) 
		WHERE HAQ.[VCC] = @VCC
			AND HAQ.[EvaluationPlanId] = @EvaluationPlanId
		ORDER BY HAQ.[Order] ASC

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
