SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetEvaluationPlanAbilitiesQueriesEntities] (
	@VCC              VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(50) = NULL
) 
AS
BEGIN
	SET NOCOUNT ON

	SELECT DISTINCT HAQE.[AbilityQueryId]								'abilityQueryId',
					HAQE.[EntityId]										'entityId',
					HAQE.[EntityName]									'entityName',
					HAQE.[AcceptancePercentage]						    'acceptancePercentage',
					ISNULL(HAQE.[AcceptancePercentage], 0) * 100		'acceptanceInteger',
					HAQE.[Order]										'order'
		FROM [dbo].[HistoricAbilityQueryEntity] HAQE (NOLOCK) 
		WHERE HAQE.[VCC] = @VCC
			AND HAQE.[EvaluationPlanId] = @EvaluationPlanId
		ORDER BY HAQE.[Order] ASC

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
