SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetGenericQueries]
(
	@VCC								VARCHAR(50) = NULL,
	@SearchCriteria						VARCHAR(50) = NULL,
	@SearchExpression					VARCHAR(50) = NULL,
	@StartDate							DATETIME,
	@EndDate							DATETIME
)
AS
BEGIN

	DECLARE @CURRENT_LANGUAGE varchar(2)
	SELECT @CURRENT_LANGUAGE = [language] from [dbo].[VCC] where [VCC] =@VCC
	
	
	DECLARE @SQL NVARCHAR(MAX) = ''

	--IF @SearchExpression = ''
    --BEGIN
		SET @SQL = '
	SET NOCOUNT ON

	
	SELECT GQ.[VCC]							''vcc'',
			GQ.[Name]							''name'',
			GQ.[Description]					''description'',
			GQ.[Query]							''query'',
			GQ.[RawData]						''rawData'',
			GQ.[CreatedDate]					''createdDate'',
			GQ.[CreatedByUserId]				''createdByUserId'',
			GQ.[LastModifiedDate]				''lastModifiedDate'',
			GQ.[LastModifiedByUserId]			''lastModifiedByUserId'',
			GQ.[Version]                        ''version'' 
		FROM GENERICQUERY (NOLOCK) GQ
		INNER JOIN ( 
			SELECT * FROM GenericQuery (NOLOCK) 
				WHERE VCC =''SYSTEM'' 
					AND [Name] LIKE ' + '''' + @CURRENT_LANGUAGE + '%' + '''
					AND ISNULL([Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
					AND ISNULL([Description], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''description'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
					AND ISNULL([Query], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''query'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
		) AS GS 
			ON GQ.[Name] = GS.[Name]	
		WHERE  GQ.[VCC]=''' + @VCC + ''' 

	UNION ALL

	'
	--END
	
	SET @SQL += '
	SELECT [VCC]							''vcc'',
			[Name]							''name'',
			[Description]					''description'',
			[Query]							''query'',
			[RawData]						''rawData'',
			[CreatedDate]					''createdDate'',
			[CreatedByUserId]				''createdByUserId'',
			[LastModifiedDate]				''lastModifiedDate'',
			[LastModifiedByUserId]			''lastModifiedByUserId'',
			[Version]                       ''version''
		FROM [dbo].[GenericQuery] (NOLOCK)
		WHERE [VCC] = ''' + @VCC + '''
			AND ISNULL([Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
			AND ISNULL([Description], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''description'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
			AND ISNULL([Query], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''query'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
			AND [NAME] NOT IN (SELECT [NAME] FROM [dbo].[GenericQuery] WHERE VCC =''SYSTEM'')
		'
		--END ESCAPE ''\''
	
	IF (@StartDate IS NOT NULL AND @EndDate IS NOT NULL)
	BEGIN
		SET @SQL += '
			--AND CONVERT(VARCHAR(10), [CreatedDate], 120) BETWEEN ''' + CONVERT(VARCHAR(10), @StartDate, 120) + ''' AND ''' + CONVERT(VARCHAR(10), @EndDate, 120) + '''
			AND [CreatedDate] BETWEEN ''' + CONVERT(VARCHAR(10), @StartDate, 120) + ''' AND ''' + CONVERT(VARCHAR(10), @EndDate, 120) + '''
			
		'
	END
	SET @SQL += '
	ORDER BY [CreatedDate] DESC
	'
	SET NOCOUNT OFF
	--PRINT @SQL
	EXEC(@SQL)
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
