SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetGenericQueryUsage]
(
	@VCC				VARCHAR(50),
	@QueryName			VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	-- Validar para Ability.
	BEGIN
		SELECT
			DISTINCT [Title]	'ability'
		FROM
			[dbo].[Ability]
		WHERE
			[Instance] = @VCC
			AND [QueryName] = @QueryName
	END

	-- Validar para TemplateThemeItem.
	BEGIN
		SELECT
			COUNT(ID) total
		FROM
			[dbo].[TemplateThemeItem]
		WHERE
			[VCC] IN(@VCC, 'system')
			AND [ID] = @QueryName
	END

	-- Validar para EvalutionPlan.
	BEGIN
		SELECT
			DISTINCT [Description]	'description'
		FROM
			[dbo].[EvaluationPlan]
		WHERE
			[Instance] = @VCC
			AND [FilterByContentQueryName] = @QueryName
			AND [Status] < 5
	END

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
