SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- SP SPEECHANALYTICS: RECUPERA LOS VCC DE LA MMPRODAT
CREATE PROCEDURE [dbo].[GetIntegratedVCCs] (
   	@VCC VARCHAR(50) = NULL,
	@IP VARCHAR(50), 
	@Type INT
) 
AS 
BEGIN 
	-- DECLARAMOS CADENAS DE TEXTO PARA EL QUERY FINAL
	DECLARE @SQL_SELECT_0 VARCHAR(MAX) = ''
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_FILTER VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''

	-- DECLARAMOS VARIABLES PARA NOS NOMBRES DE LAS TABLAS
	DECLARE @VCC_SERVICE_TABLE NVARCHAR(100)
	DECLARE @SYSTEM_SERVICE_TABLE NVARCHAR(100)

	-- EL PARAMETRO TYPE DEFINE SI LA BD ALLEGRO SE ENCUENTRA LOCAL O REMOTO
	IF (@Type = 0)  
	BEGIN  
		SET @VCC_SERVICE_TABLE = '[' + @Ip + ']' + '.[mmprodat].[dbo].[VCCService]'
		SET @SYSTEM_SERVICE_TABLE = '[' + @Ip + ']' + '.[mmprodat].[dbo].[SystemService]'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @VCC_SERVICE_TABLE = '[mmprodat].[dbo].[VCCService]';
		SET @SYSTEM_SERVICE_TABLE = '[mmprodat].[dbo].[SystemService]';
	END  

	-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
	SET @SQL_SELECT_1 += '
		SELECT '

	SET @SQL_SELECT_1 += '
				VS.[VCC] ''vcc'',
				SUM(CASE WHEN SS.[Type] = ''OMNICHANNELINTEGRATION'' THEN 1 ELSE 0 END) ''hasOmnichannel'' -- 1: OCC OR 0: ALLEGRO ' 

	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += '
			FROM ' + @VCC_SERVICE_TABLE + ' VS (NOLOCK)
			LEFT JOIN ' + @SYSTEM_SERVICE_TABLE + ' SS (NOLOCK) 
				ON SS.[Id] = VS.[ServiceId] '

	-- ARMAMOS LA PARTE DE FILTROS
	SET @SQL_FILTER += '' 

	-- ARMAMOS LA PARTE DE EXTRAS
	SET @SQL_EXTRA += '
			GROUP BY VS.[VCC]
			ORDER BY VS.[VCC] ASC '

	-- UNIMOS LAS PARTES DEL QUERY
	SET @SQL_SELECT_1 += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA

	-- EJECUTAMOS LA CONSULTA
	EXEC (@SQL_SELECT_1)
	
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
