SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetInteractionTypes] (
	@Instance VARCHAR(50) = NULL,
	@SearchCriteria VARCHAR(50) = NULL,
	@SearchExpression VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- VERIFICAMOS IS ESTAMOS BUSCANDO DE EVALUACIONES PENDIENTES
	IF @SearchCriteria IS NOT NULL AND @SearchCriteria = 'PENDING'
	BEGIN
		SELECT DISTINCT AEP.[Instance]					'instance',
						AEP.[InteractionType]			'id',
						AEP.[InteractionType]			'description'
			FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
			WHERE AEP.[Instance] = @Instance
				AND AEP.[Completed] = 0
	END
	ELSE
	BEGIN
 		SELECT IT.[Instance]						'instance',
				IT.[ID]							'id',
				IT.[Description]					'description'
			FROM [dbo].[InteractionType] IT (NOLOCK)
			WHERE IT.[Instance] = @Instance
				AND ISNULL(IT.[ID], '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
				AND ISNULL(IT.[Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' COLLATE Latin1_General_CI_AI ELSE '%' END
	END

 	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
