SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
--[dbo].[GetProcessSummary] 'inconcert', '1FC1C683-191F-4A46-A932-31C5D8116FC2'
CREATE PROCEDURE [dbo].[GetProcessSummary]
(
	@VCC					VARCHAR(50),
	@ProcessId				VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	-- PARA NO HACER UNA MODIFICACION DEMASIADO FUERTE AL SP, BUSCAMOS EL TIEMPO PROCESADO POR SEPARADO

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL ACUMULADO DE TIEMPO PROCESADO
	DECLARE @TOTAL_DURATION_LINGUISTIC_TIME INT = 0

	-- CONSULTAMOS EL TOTAL DE TIEMPO PROCESADO DE LOS AUDIOS DEL PROCESO
	SELECT @TOTAL_DURATION_LINGUISTIC_TIME = SUM(A.[DurationLinguisticTime]) 
		FROM [dbo].[ProcessAudio] PA (NOLOCK)
		LEFT JOIN [dbo].[Audio] A (NOLOCK)
			ON A.[ID] = PA.[AudioId] 
				AND A.[Section] = PA.[Section]
				AND A.[Part] = PA.[Part]
		WHERE PA.VCC = @VCC 
				AND PA.[ProcessId] = @ProcessId

	SELECT
		[VCC]																			'vcc',
		[ProcessId]																		'processId',
		[SilenceTime]																	'silenceTime',
		[AverageSilenceTime]															'averageSilenceTime',
		[DurationTime]																	'durationTime',
		CONVERT(varchar, DATEADD(ms, @TOTAL_DURATION_LINGUISTIC_TIME * 1000, 0), 108)	'durationLinguisticTime',
		[AverageDurationTime]															'averageDurationTime',
		[DurationTimeRate]																'durationTimeRate',
		[CreatedDate]																	'createdDate',
		[CreatedByUserId]																'createdByUserId',
		[LastModifiedDate]																'lastModifiedDate',
		[LastModifiedByUserId]															'lastModifiedByUserId'
	FROM [dbo].[ProcessSummary] (NOLOCK)
	WHERE [VCC] = @VCC AND [ProcessId] = @ProcessId

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
