SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetProcessUsage]
(
	@VCC				VARCHAR(50),
	@ProcessId			VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	BEGIN
		-- Validar para Proceso. Avisar si esta en progreso.
		SELECT [Name]				'name'
			FROM [dbo].[Process] (NOLOCK)
			WHERE [VCC] = @VCC
				AND [Name] = @ProcessId
				AND [Status] NOT IN('COMPLETE', 'FAILED')
	END

	-- LISTAMOS LOS ESTUDIOS REGULARES
	BEGIN
		-- Validar para Estudio. Avisar si esta asociado a un estudio.
		SELECT DISTINCT [Name]		'name'
			FROM [dbo].[Study] (NOLOCK)
			WHERE [VCC] = @VCC
				AND [ProcessId] = @ProcessId
				AND [Type] = 'SPEECH'
	END

	-- LISTAMOS LOS ESTUDIOS DE PLANTILLA AGENDADA
	BEGIN
		SELECT DISTINCT [Name]		'name'
			FROM [dbo].[Study] (NOLOCK)
			WHERE [VCC] = @VCC
				AND [ProcessId] = @ProcessId
				AND [Type] = 'TEMPLATE'
	END

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
