SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
--exec [GetRole] 'bpo', NULL
CREATE PROCEDURE [dbo].[GetRole] (
	@VCC Varchar(50) = NULL, @RoleId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @CountLicense INT, @License VARCHAR(50)
	

	SET @CountLicense = (SELECT COUNT(*) FROM VCCLicense (NOLOCK) WHERE [VCC] =@VCC AND [Status] = 1 )	

	SELECT
		[ID]							'id',
		[Description]					'description',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId',
		[SystemRole]					'systemRole'
	FROM [Role] (NOLOCK)
	WHERE [VCC] = @VCC
	AND [ID] = CASE WHEN ISNULL(@RoleId, '') = '' THEN [ID] ELSE @RoleId END

	IF(@CountLicense>1)
	BEGIN
		EXEC [GetRolePermission] @VCC, @RoleId
		EXEC [GetRoleRoutePermission] @VCC, @RoleId
		EXEC [GetRoleSinglePermission] @VCC, @RoleId
		EXEC [dbo].[GetRoleCategories] @VCC, @RoleId
	END
	IF(@CountLicense=1)
	BEGIN
		SET @License = (SELECT Product FROM VCCLicense (NOLOCK) WHERE [VCC] =@VCC AND [Status] = 1)
		EXEC [GetRolePermission] @VCC, @RoleId, @License 
		EXEC [GetRoleRoutePermission] @VCC, @RoleId, @License
		EXEC [GetRoleSinglePermission] @VCC, @RoleId, @License
		EXEC [dbo].[GetRoleCategories] @VCC, @RoleId
	END
	IF(@CountLicense<1)
	BEGIN
		EXEC [GetRolePermission] 'empty', @RoleId
		EXEC [GetRoleRoutePermission] 'empty', @RoleId
		EXEC [GetRoleSinglePermission] 'empty', @RoleId
		EXEC [dbo].[GetRoleCategories] 'empty', @RoleId
	END

	
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
