SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetRoleCategories] (
	@VCC VARCHAR(50), 
	@RoleId VARCHAR(50) = NULL,
	@License Varchar(50) = NULL
) AS
BEGIN
	-- ESTE SP RETORNA LAS CATEGORIAS RELACIONADAS A UN USUARIO
	
	SELECT RPG.[Category]					'categoryId'
		FROM [dbo].[RolePermission] RP (NOLOCK)
		INNER JOIN [dbo].[RolePermissionsGroup] RPG (NOLOCK)
			ON RPG.[VCC] = RP.[VCC]
				AND RPG.[GroupId] = RP.[GroupId]
		WHERE RP.[VCC] = @VCC
			AND RP.[RoleId] = CASE WHEN ISNULL(@RoleId, '') = '' THEN rp.[RoleId] ELSE @RoleId END
			AND (@License IS NULL OR RPG.[Type] IN (@License, 'SHARED'))
		GROUP BY RP.[VCC], RPG.[Category] 
		ORDER BY RPG.[Category] ASC
	
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
