SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetRolePermission] (
	@VCC Varchar(50) = NULL, @RoleId Varchar(50) = NULL, @License Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		rp.[RoleId]							'roleId',
		rp.[GroupId] 							'groupId'
	FROM [RolePermission] rp(NOLOCK)
	LEFT JOIN RolePermissionsGroup rpg (NOLOCK)
		ON rpg.GroupId = rp.[GroupId]
	WHERE rp.[VCC] = @VCC
		AND rp.[RoleId] = CASE WHEN ISNULL(@RoleId, '') = '' THEN rp.[RoleId] ELSE @RoleId END
		AND ( @License IS NULL OR rpg.Type in( @License,'SHARED') )
		AND rpg.[GroupId] IN (
			SELECT GroupId
				FROM [RolePermission] (NOLOCK)
				WHERE VCC = @VCC
					AND RoleId = CASE WHEN ISNULL(@RoleId, '')='' THEN RoleId ELSE @RoleId END)
	GROUP BY rp.[RoleId], rp.GroupId
	ORDER BY rp.[RoleId] ASC, rp.[GroupId] ASC
	
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
