SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetStudiesInProcess]
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[VCC]				'vcc',
		[ProcessId]			'processId',
		TemplateId			'templateId',
		[studyId]			'studyId',
		SUM(Total)			'total'
	FROM (SELECT S.[VCC]				'vcc',
		S.[ProcessId]					'processId',
		S.TemplateId					'templateId',
		S.[Name]						'studyId',
		COUNT(DISTINCT TTI.[ID])		'total'
	FROM
		[dbo].[Study] S WITH (NOLOCK)
		INNER JOIN [dbo].[TemplateThemeItem] TTI WITH (NOLOCK) ON S.[TemplateId] = TTI.[TemplateId]
		INNER JOIN [dbo].[GenericQuery] GQ WITH (NOLOCK) ON TTI.[ID] = GQ.[Name]
	WHERE S.[Status] < 1
	GROUP BY
		S.[VCC],
		S.[ProcessId],
		S.[Name],
		S.TemplateId
	UNION ALL
	SELECT A.[VCC]			'vcc',
		A.[ProcessId]		'processId',
		A.TemplateId		'templateId',
		A.[studyId]			'studyId',
		COUNT(1)			'total'
	FROM (SELECT DISTINCT
				A.VCC				'vcc'
				,A.ProcessId		'processId'
				,A.[Name]			'studyId'
				,D.AudioId			'id'
				,D.Section			'section'
				,D.Part				'part'
				,B.TemplateId		'templateId'
				,C.nluId			'nluId'
				,C.appId			'appId'
				,E.[FileName]		'fileName'
			FROM [dbo].[Study] A (NOLOCK)
			INNER JOIN [dbo].[TemplateThemeItem] B WITH (NOLOCK) ON A.VCC = B.VCC AND A.[TemplateId] = B.[TemplateId]
			INNER JOIN (SELECT DISTINCT
					A.VCC 'vcc'
					,A.[Name] + '|'+ B.[Name] 'cognitiveId'
					,A.[Name] 'nluId'
					,A.AppId 'appId'
				FROM NLU A (NOLOCK)
				INNER JOIN Intent B (NOLOCK) ON A.VCC = B.VCC) C ON A.VCC = C.VCC AND B.ID = C.cognitiveId
			INNER JOIN [dbo].[ProcessAudio] D WITH (NOLOCK) ON A.VCC = D.VCC AND A.ProcessId = D.ProcessId
			INNER JOIN [dbo].[Audio] E WITH (NOLOCK) ON A.VCC = E.VCC AND D.AudioId = E.ID AND D.Section = E.Section AND D.Part = E.Part
			WHERE A.[Status] < 1) A
		GROUP BY
		A.[VCC],
		A.[ProcessId],
		A.TemplateId,
		A.[studyId]) A
		GROUP BY
		A.[VCC],
		A.[ProcessId],
		A.TemplateId,
		A.[studyId]

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
