SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetStudyGenericQueryTask]
(
	@VCC				VARCHAR(50),
	@ProcessId			VARCHAR(50),
	@StudyId			VARCHAR(200)
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT DISTINCT
		S.[VCC]				'vcc',
		S.[ProcessId]		'processId',
		TTI.[ID]			'queryId',
		S.[Name]			'studyId'
	FROM [dbo].[Study] S (NOLOCK)
	INNER JOIN [dbo].[TemplateThemeItem] TTI (NOLOCK) 
		ON TTI.[VCC] = S.[VCC]
			AND S.[TemplateId] = TTI.[TemplateId]
	INNER JOIN [dbo].[GenericQuery] GQ (NOLOCK) 
		ON GQ.[VCC] = S.[VCC]
			AND TTI.[ID] = GQ.[Name]
	WHERE
		S.[VCC] = @VCC
		AND S.[ProcessId] = @ProcessId
		AND S.[Name] = @StudyId

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
