SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- [dbo].[GetStudyReport] '2019-03-08', '2019-03-20', 'callyou_colombia,Quality_test_custom'
CREATE PROCEDURE [dbo].[GetStudyReport]
(
	@StartDate VARCHAR(10),
	@EndDate VARCHAR(10),
	@Processes VARCHAR(800)
)
AS
BEGIN
	DECLARE @SQL NVARCHAR(MAX)
	SET @SQL = '
	SET NOCOUNT ON

	SELECT
		A.ProcessId AS processId,
		A.[TemplateId] AS templateId,
		A.[Name] AS studyId,
		B.[Category1] AS theme,
		B.[Category2] AS subTheme1,
		B.[Description] AS subTheme2,
		C.[TranscriptionId] AS interactionId,
		D.[Section] AS section,
		D.[Part] AS part,
		D.[Agent] AS agent,
		A.[CreatedDate] AS createdDate
	FROM [dbo].[Study] A (NOLOCK)
	INNER JOIN [dbo].[StudyResultSummary] B (NOLOCK) ON A.[Name] = B.[StudyId]
	INNER JOIN [dbo].[StudyResultSummaryDetail] C (NOLOCK) ON A.[Name] = C.[StudyId]
	INNER JOIN [dbo].[Audio] D (NOLOCK) ON C.[TranscriptionId] = D.[ID]
	WHERE
		A.[CreatedDate] BETWEEN ''' + @StartDate + ' 00:00:00.000'' AND ''' + @EndDate + ' 23:59:59.999'' AND
		A.[ProcessId] IN(SELECT value FROM [dbo].[SplitString](''' + @Processes + ''', '',''))

	SET NOCOUNT OFF
	'
	EXEC sp_executesql @SQL
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
