SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetTipifications] (
	@VCC VARCHAR(50) = NULL, 
	@SearchCriteria VARCHAR(50) = NULL, 
	@SearchExpression VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT T.[ID]							'id',
			T.[Description]					'description'
		FROM [dbo].[Tipification] T (NOLOCK)
		WHERE T.[VCC] = @VCC
			AND ISNULL(T.[Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
		ORDER BY T.[Description] ASC
		
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
