SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- [dbo].[GetUtterancesByInteraction] 'allegro', '{f2c9e160-8eeb-11e9-8562-b65bb2fb6bcb}', 0, 1
CREATE PROCEDURE [dbo].[GetUtterancesByInteraction]
(
	@VCC			VARCHAR(50),
	@AudioId		VARCHAR(50),
	@Section		NUMERIC(5, 0),
	@Part			NUMERIC(5, 0)
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		U.[VCC]							'vcc',
		UT.[AppId]							'appId',
		UT.[IntentId]						'intentId',
		U.[AudioId]						'audioId',
		U.[Section]						'section',
		U.[Part]							'part',
		U.[Speaker]						'speaker',
		U.[AnchorOffset]					'anchorOffset',
		U.[FocusOffset]					'focusOffset',
		U.[CurrentTime]					'currentTime',
		U.[EndCurrentTime]				'endCurrentTime',
		U.[UtteranceId]					'utteranceId',
		UT.[Text]					'textContent',
		U.[CreatedDate]					'createdDate',
		U.[CreatedByUserId]				'createdByUserId',
		U.[LastModifiedDate]				'lastModifiedDate',
		U.[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM
		[dbo].[Underlined] U WITH (NOLOCK) 
		JOIN [dbo].[Utterance] UT (NOLOCK) 
		ON (U.[VCC] = UT.[VCC] AND U.[UtteranceId] = UT.[Id])
	WHERE
		U.[VCC] = @VCC
		AND U.[AudioId] = @AudioId
		AND U.[Section] = @Section
		AND U.[Part] = @Part

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
