SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[ReportAuditsByAgent] (
-- Debe venir siempre un unico formato evaluacion, si no viene no camina
   @Instance VARCHAR(50) = NULL,
   @IdEvaluationFormat VARCHAR(50) = NULL,
   @IdsCampanias VARCHAR(1000) = NULL,
   @IdAgente INT = NULL,
   @FechaDesde DATE =  NULL,
   @FechaHasta DATE = NULL,
   @IdAuditor VARCHAR(50) = NULL,
   @PlanAuditoria INT = NULL
   )
AS
BEGIN
DECLARE @columns VARCHAR(MAX),
	@columnsName VARCHAR(MAX),
	@columnsFLOAT VARCHAR(MAX),
	@insertVar VARCHAR(MAX),
	@idAgent VARCHAR(50),
	@idInteraction VARCHAR(50),
	@idEvaluationPlan VARCHAR(50),
	@idAgentAnterior VARCHAR(50) = NULL,
	@CreatedDate DATETIME,
	@CreatedDateAnterior DATETIME = NULL,
	@qualification FLOAT,
	@maxAbilityScore FLOAT, 
	@porcentajeAbilidad FLOAT,
	@cantAuditoriasAgente INT = 0,
	@cantAgentes INT = 0,
	@idHabilidad VARCHAR(50),
	@idInteractionAnterior VARCHAR(50),
	@idEvaluationPlanAnterior VARCHAR(50),
	@idAuditorAnterior VARCHAR(50),
	@ConsultaSQLsum VARCHAR(MAX),
	@columnsInsert VARCHAR(MAX),
	@columnsInsertLength INT,
	@columnsValuesLength INT

	SET NOCOUNT ON
	-- Insercion de datos retornados de filtro en tabla temporal.
	CREATE TABLE #EvaluationResult (
		Instance			VARCHAR(50),
		IdAgent				VARCHAR(50),
		CreatedDate			DATETIME,
		Qualification		NUMERIC(5, 2),
		MaxAbilityScore		NUMERIC(5, 2),
		IdAbility			VARCHAR(50),
		AbilityOrder		NUMERIC(4, 0),
		IdAuditor			VARCHAR(50),
		IdInteraction		VARCHAR(50),
		IdEvaluationPlan	VARCHAR(50),
		IdEvaluationFormat	VARCHAR(50)
	)
	INSERT INTO #EvaluationResult
	SELECT
		Instance, IdAgent, CreatedDate, Qualification, MaxAbilityScore, IdAbility, AbilityOrder, IdAuditor, IdInteraction, IdEvaluationPlan, IdEvaluationFormat
	FROM
		EvaluationResult
	WHERE
		Instance = @Instance
		AND CreatedDate BETWEEN CONVERT(VARCHAR, @FechaDesde) + ' 00:00:00.000' AND CONVERT(VARCHAR, @FechaHasta) + ' 23:59:59.999'
		AND IdEvaluationFormat = @IdEvaluationFormat-- TODO ajustar en base a demas filtros que se definan.

	-- Variable para validar cantidad de registros.
	DECLARE @COUNT INT
	SET @COUNT = (SELECT COUNT(IdInteraction) FROM #EvaluationResult)
	PRINT '@COUNT: ' + CONVERT(VARCHAR, @COUNT)
	
	IF(@COUNT > 0)
	BEGIN
		-- Continua con desarrollo de cursor.
		DECLARE curP CURSOR LOCAL FOR
			SELECT
				IdAgent, CreatedDate, Qualification, MaxAbilityScore, IdAbility,IdAuditor, IdInteraction, IdEvaluationPlan
			FROM
				EvaluationResult
			WHERE
				Instance = @Instance
				AND CreatedDate BETWEEN CONVERT(VARCHAR, @FechaDesde) + ' 00:00:00.000' AND CONVERT(VARCHAR, @FechaHasta) + ' 23:59:59.999'
				AND IdEvaluationFormat = @IdEvaluationFormat-- TODO ajustar en base a demas filtros que se definan.
				-- AND IdAgent = 'elin.engman'
			ORDER BY IdAgent, IdEvaluationPlan, IdInteraction, idauditor,  IdAbility

			-- Danny Jhonston:
			-- Inicio: Se anade mapeo a nombre de habilidades.
			SELECT @columns = COALESCE(@columns + ', ', '') + '[' + idAbility + '] VARCHAR(50)',
			@columnsName = COALESCE(@columnsName + ', ', '') + '''' + Title + ''''
			FROM (SELECT DISTINCT ER.idAbility, ER.AbilityOrder, A.Title FROM #EvaluationResult ER
			INNER JOIN Ability A ON ER.IdAbility = A.ID
			WHERE
				ER.Instance = @Instance
				AND ER.CreatedDate BETWEEN CONVERT(VARCHAR, @FechaDesde) + ' 00:00:00.000' AND CONVERT(VARCHAR, @FechaHasta) + ' 23:59:59.999'
				AND ER.IdEvaluationFormat = @IdEvaluationFormat) VW
			ORDER BY IdAbility
			PRINT '@columnsName: ' + @columnsName
			-- Danny Jhonston:
			-- Fin: Se anade mapeo a nombre de habilidades.


			PRINT '@columns: ' + @columns
			PRINT '@columnsName: ' + @columnsName
			----print 'Analiznado InteracionId: ' 
			----print ISNULL(@IdInteraction,'')
			----print 'columns '
			----print @columns

			CREATE TABLE #T1(
				Agente VARCHAR(50)
			)

			IF @columns IS NOT NULL AND @columns <> ''
			BEGIN
				EXEC('ALTER TABLE #T1 ADD ' + @columns)

				PRINT @columns

				----PRINT 'agregadas columnas a t1'
				----PRINT @columnsName

				----PRINT ('Ejecutando SQL ....')
				----PRINT ('INSERT INTO #T1 VALUES (''Agente'','+@columnsName+')')
				-- Agrego en la primer fila los titulos de las columnas

				CREATE TABLE #TableTempColumns(
					[name] VARCHAR(100)
				)
		
				-- Danny Jhonston:
				-- Inicio: Almaceno las columnas de la tabla temporal #T1 a excepcion de la columna Agente.
				INSERT INTO #TableTempColumns
				SELECT [name] FROM tempdb.sys.columns
				WHERE OBJECT_ID = OBJECT_ID('tempdb..#T1')
				-- Danny Jhonston:
				-- Fin: Almaceno las columnas de la tabla temporal #T1 a excepcion de la columna Agente.


				-- Danny Jhonston:
				-- Inicio: Para el error: Column name or number of supplied values does not match table definition, se decide obtener las columnas para anadirlas en la sentencia INSERT INTO #T.
				SET @columnsInsert = (SELECT STUFF((SELECT + ', [' + [name] + ']' FROM
				#TableTempColumns FOR XML PATH('')), 1, 1, ''))
				PRINT '@columnsInsert: ' + @columnsInsert
				-- Danny Jhonston:
				-- Fin: Para el error: Column name or number of supplied values does not match table definition, se decide obtener las columnas para anadirlas en la sentencia INSERT INTO #T.


				-- Agrego en la primera fila los titulos de las columnas.
				PRINT('INSERT INTO #T1 (' + @columnsInsert + ') VALUES (''Agente'',' + @columnsName + ')')
				EXEC('INSERT INTO #T1 (' + @columnsInsert + ') VALUES (''Agente'',' + @columnsName + ')')
	
				CREATE TABLE #PromediosAgente(
					Agente VARCHAR(50)
				)

				EXEC('ALTER TABLE #PromediosAgente ADD ' + @columns) -- Anade columnas.
				INSERT INTO #PromediosAgente (Agente) VALUES ('Promedios sobre X auditorias') -- Anade el texto para la columna.

				CREATE TABLE #PromediosGenerales(
					Agente VARCHAR(50)
				)

				EXEC('ALTER TABLE #PromediosGenerales ADD ' + @columns)
				INSERT INTO #PromediosGenerales (Agente) VALUES ('Promedios Generales')


				OPEN curP
				FETCH NEXT FROM curP INTO @idAgent, @CreatedDate, @qualification, @maxAbilityScore, @idHabilidad, @IdAuditor, @IdInteraction, @IdEvaluationPlan

				PRINT '@IdEvaluationPlan: ' + @IdEvaluationPlan

				SET @idAgentAnterior = @idAgent
				SET @CreatedDateAnterior = @CreatedDate
				SET @insertVar = ''''+@idAgent+''''
				SET @cantAuditoriasAgente = @cantAuditoriasAgente + 1
				SET @IdAuditorAnterior = @IdAuditor
				SET @IdInteractionAnterior = @IdInteraction
				SET @IdEvaluationPlanAnterior = @IdEvaluationPlan
				SET @ConsultaSQLsum = ''
		
				WHILE @@FETCH_STATUS = 0
				BEGIN
					IF @IdAuditorAnterior != @IdAuditor OR @IdInteractionAnterior != @IdInteraction OR @IdEvaluationPlanAnterior != @IdEvaluationPlan
					BEGIN
						--PRINT @columnsName
						--PRINT @insertVar
						PRINT 'insertvar: ' + ISNULL(@insertVar,'NULLL')
						--PRINT 'analizando 2do insert'
						PRINT ' '
						PRINT '@IdAuditor: ' + @IdAuditor + ' @IdEvaluationPlan: ' + @IdEvaluationPlan + ' @idHabilidad: ' + @idHabilidad

						-- Validar que la cantidad de columnas coincida con la cantidad de valores a insertar.
						PRINT ''
						PRINT '********'
						PRINT @columnsInsert
						PRINT @insertVar
						SET @columnsInsertLength = (SELECT COUNT([value]) FROM [dbo].[SplitString](@columnsInsert, ','))
						PRINT @columnsInsertLength

						SET @columnsValuesLength = (SELECT COUNT([value]) FROM [dbo].[SplitString](@insertVar, ','))
						PRINT @columnsValuesLength
						IF(@columnsInsertLength = @columnsValuesLength)
						BEGIN
							PRINT ('INSERT INTO #T1 (' + @columnsInsert + ') VALUES(' + @insertVar +')')
							EXEC ('INSERT INTO #T1 (' + @columnsInsert + ') VALUES('+ @insertVar +')')	
						END
						PRINT '********'
						PRINT ''
						SET @insertVar = '''' + @idAgent + ''''
						SET @cantAuditoriasAgente = @cantAuditoriasAgente + 1
					END
					PRINT @idAgentAnterior + ' - ' + @idAgent
					IF @idAgentAnterior!= @idAgent
					BEGIN
						PRINT 'XXXXXXXX'
						PRINT @idAgent
						-- Danny Jhonston:
						-- Inicio: Actualizar valores sumarizados sobre cantidad de auditorias de agente para obtener promedios.
						SET @ConsultaSQLsum = 'UPDATE #PromediosAgente SET ' + (SELECT STUFF((SELECT + ', [' + [name] + '] = ROUND(CONVERT(FLOAT, [' + [name] + ']) / CONVERT(FLOAT, ' + CONVERT(VARCHAR, (@cantAuditoriasAgente-1)) + '), 2)' FROM
												#TableTempColumns
												WHERE [name] NOT IN('Agente') FOR XML PATH('')), 1, 1, ''))
						PRINT '@ConsultaSQLsum: ' + @ConsultaSQLsum
						EXEC (@ConsultaSQLsum)
						-- Danny Jhonston:
						-- Fin: Actualizar valores sumarizados sobre cantidad de auditorias de agente para obtener promedios.

						IF @cantAuditoriasAgente-1 = 1
						BEGIN
							UPDATE #PromediosAgente SET
							Agente = Replace(Agente, 'X auditorias', CONVERT(VARCHAR, @cantAuditoriasAgente-1)+' auditoria')
						END
						ELSE
						BEGIN
							UPDATE #PromediosAgente SET
							Agente = Replace(Agente, 'X', CONVERT(VARCHAR, @cantAuditoriasAgente-1))
						END
						-- PRINT 'actualizados promedios'
						-- Insertamos sumarizacion agente.

						INSERT #T1 SELECT * FROM #PromediosAgente
						DELETE FROM #PromediosAgente
						INSERT INTO #PromediosAgente (Agente) VALUES ('Promedios sobre X auditorias')
						--PRINT 'insertado promedios'
						SET @cantAuditoriasAgente = 1
					END
				
					SET @CreatedDateAnterior = @CreatedDate
					SET @idAgentAnterior = @idAgent
					SET @IdAuditorAnterior = @IdAuditor
					SET @IdInteractionAnterior = @IdInteraction
					SET @IdEvaluationPlanAnterior = @IdEvaluationPlan
					SET @porcentajeAbilidad = (ISNULL(@qualification, 0) * 100.0) / HistoricalData.dbo.IsZero(ISNULL(@maxAbilityScore, 0), 0)
					PRINT '$$$$$$$$$$$$$$$$$'
					PRINT ''
					PRINT ''
					PRINT '@qualification: ' + CONVERT(VARCHAR, @qualification) + ' @porcentajeAbilidad: ' + CONVERT(VARCHAR, @porcentajeAbilidad) + ' @maxAbilityScore: ' + CONVERT(VARCHAR, @maxAbilityScore)
					PRINT ''
					PRINT ''
					-- PRINT 'actualizando promedios 2'
					DECLARE @ConsultaSQL1 VARCHAR(MAX)

					-- Danny Jhonston:
					-- Inicio: Actualizar porcentaje de habilidad para cada habilidad.
					SET @ConsultaSQL1 = 'UPDATE #PromediosAgente SET [' + @idHabilidad + '] = CAST(ISNULL([' + @idHabilidad + '], 0) AS FLOAT) +' + CONVERT(VARCHAR, @porcentajeAbilidad)			

					--SELECT @ConsultaSQL1 = 'UPDATE #PromediosAgente SET [' + @idHabilidad + '] = ' + 'CONVERT(VARCHAR, (IsNull(CONVERT(FLOAT, [' + @idHabilidad + ']), 0))) *'  
					--SELECT @ConsultaSQL2 = '(( ' + CONVERT(VARCHAR,@cantAuditoriasAgente) + ' + -1) +' + CONVERT(VARCHAR, @porcentajeAbilidad) + ')/ + ' + CONVERT(VARCHAR, @cantAuditoriasAgente)
					--SELECT @ConsultaSQL3 = @ConsultaSQL1 + ' ' + @ConsultaSQL2
					--print '@ConsultaSQL3: ' + @ConsultaSQL3
					--print '@ConsultaSQL1: ' + @ConsultaSQL1
			
					--print '____@idHabilidad: ' + @idHabilidad + ' @porcentajeAbilidad: '+  CONVERT(VARCHAR, @porcentajeAbilidad) + '@cantAuditoriasAgente: ' + CONVERT(VARCHAR,@cantAuditoriasAgente) + ' dummy: ' + CONVERT(VARCHAR,@dummy)
					PRINT ''
					PRINT ''
					PRINT ''
					PRINT '**********|||||||||'
					PRINT('@ConsultaSQL1: ' + @ConsultaSQL1)
					EXEC(@ConsultaSQL1)
					-- Danny Jhonston:
					-- Fin: Actualizar porcentaje de habilidad para cada habilidad.


					SET @insertVar = COALESCE(@insertVar + ', ', '') + '''' + CONVERT(VARCHAR, @porcentajeAbilidad) + ''''
					FETCH NEXT FROM curP INTO @idAgent, @CreatedDate, @qualification, @maxAbilityScore, @idHabilidad, @IdAuditor, @IdInteraction, @IdEvaluationPlan
					PRINT '_______________________' + CONVERT(VARCHAR, @@FETCH_STATUS)

					-- En la ultima iteracion ejecutar sintaxis para promediar.
					IF(@@FETCH_STATUS = -1)
					BEGIN
						-- Danny Jhonston:
						-- Inicio: Actualizar valores sumarizados sobre cantidad de auditorias de agente para obtener promedios.
						SET @ConsultaSQLsum = 'UPDATE #PromediosAgente SET ' + (SELECT STUFF((SELECT + ', [' + [name] + '] = ROUND(CONVERT(FLOAT, [' + [name] + ']) / CONVERT(FLOAT, ' + CONVERT(VARCHAR, (@cantAuditoriasAgente)) + '), 2)' FROM
												#TableTempColumns
												WHERE [name] NOT IN('Agente') FOR XML PATH('')), 1, 1, ''))
						PRINT '@ConsultaSQLsum: ' + @ConsultaSQLsum
						EXEC (@ConsultaSQLsum)
						-- Danny Jhonston:
						-- Fin: Actualizar valores sumarizados sobre cantidad de auditorias de agente para obtener promedios.
					END
				END -- END WHILE

				--PRINT ' @cantAuditoriasAgente: ' + CONVERT(VARCHAR, @cantAuditoriasAgente)

			-- Inicio de segundo row - promedio de notas.
			PRINT 'Insertando en t1 SQL: ' + ('INSERT INTO #T1 (' + @columnsInsert + ') VALUES('+ ISNULL(@insertVar, 'NULL') +')')

			EXEC ('INSERT INTO #T1 (' + @columnsInsert + ') VALUES (' + @insertVar  + ')' )

			-- PRINT 'insertados! en t1 2'
			IF @cantAuditoriasAgente = 1
			BEGIN
				UPDATE #PromediosAgente SET
				Agente = Replace(Agente, 'X auditorias', CONVERT(VARCHAR, @cantAuditoriasAgente) +' auditoria')
			END
			ELSE
			BEGIN
				UPDATE #PromediosAgente SET
				Agente = Replace(Agente, 'X', CONVERT(VARCHAR, @cantAuditoriasAgente))
			END

			INSERT #T1 SELECT * FROM #PromediosAgente
		CLOSE curP
		DEALLOCATE curP

		-- Danny Jhonston:
		-- Inicio: Se anade mapeo a nombre de habilidades para campos del resultSet.
		DECLARE @Headers VARCHAR(MAX)
		SET @Headers = (SELECT STUFF((SELECT + ', [' + A.[ID] + '] AS [' + A.[Title] + ']' FROM
		#TableTempColumns temp
		INNER JOIN Ability A ON temp.[name] = A.ID
		WHERE temp.[name] NOT IN('Agente') FOR XML PATH('')), 1, 1, ''))


		DECLARE @SQL VARCHAR(MAX)
		SET @SQL = '
			SELECT Agente, '
		SET @SQL += @Headers
		SET @SQL += ' FROM #T1
		'
		EXEC (@SQL)
		-- Danny Jhonston:
		-- Fin: Se anade mapeo a nombre de habilidades.
		END
	END
	ELSE
	BEGIN
		SELECT '-1' AS result
	END
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
