SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE [dbo].[ReportByDetailAgent] (
	@VCC varchar(50) = NULL, 
	@HistoricCampaign varchar(MAX) = NULL , 
	@Plan varchar(MAX) = NULL,
	@Format varchar(MAX), 
	@StartDate DateTime = NULL , 
	@EndDate DateTime = NULL , 
	@IdAuditor varchar(MAX) = NULL ,
	@IdAgente varchar(MAX) = NULL
) AS
  DECLARE @cols varchar(max) 
  DECLARE @query varchar(max)
  
  -- ReportByDetailAgent 'allegro','entrantes','Plan_2_nov01-0356','nov01-0356','20191001','20191201','isidoro','icagente3'
  SET NOCOUNT ON

  SELECT
    * INTO #TempEvaluationResult
  FROM (
	SELECT EP.[Instance]														'VCC',
			EP.[Description]													'DescriptionPlan',
			EF.[Description]													'DescriptionFormat',
			(
				GP.[Description]
				+ '-' 
				+ SGP.[Description]
				+ '-' 
				+ A.[Title]
			)																	'Ability', --Collate SQL_Latin1_General_CP1253_CI_AI
			ER.[AgentDescription],
			ER.[CampaignDescription],
			ER.[IdInteraction],
			ISNULL(ER.[Qualification], 0)										'Qualification',
			AEP.[Score]															'Score',
			AEP.[AutomaticScore],
			AEP.[ManualScore],
			--Format(ER.EvaluationDate, 'dd/MM/yyyy hh:mm:ss')					AS 'EvaluationDate',
			--CAST(Format(AEP.[TimeStamp], 'yyyy-MM-dd hh:mm:ss') AS DATETIME)					AS 'EvaluationDate',
			AEP.[TimeStamp] AS 'EvaluationDate',
			ER.[IdAuditor],
			EP.[Evaluation_Mode]
		FROM dbo.[EvaluationResult] (NOLOCK) ER
		INNER JOIN dbo.[HistoricEvaluationFormat] EF
			ON EF.[VCC] = ER.[Instance]
				AND ER.[IdEvaluationFormat] = EF.ID 
				AND ER.[IdEvaluationPlan] = EF.[EvaluationPlanId]
		INNER JOIN dbo.[HistoricAbility] (NOLOCK) A
			ON A.[VCC] = ER.[Instance]
				AND ER.[IdEvaluationPlan] = A.[EvaluationPlanId]
				AND A.[ID] = ER.[IdAbility] 
		INNER JOIN dbo.[EvaluationPlan] (NOLOCK) EP
			ON EP.[Instance] = ER.[Instance]
				AND EP.[ID] = ER.[IdEvaluationPlan]
		INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) 
			ON AEP.[Instance] = ER.[Instance]
				AND AEP.[IdEvaluationPlan] =  ER.[IdEvaluationPlan]
				AND AEP.[IdInteraction] = ER.[IdInteraction]
				AND AEP.[IdAuditor] =  ER.[IdAuditor]
		LEFT JOIN [HistoricGroup] (NOLOCK) GP
			ON GP.[VCC] = ER.[Instance]
				AND GP.[EvaluationPlanId] = EP.ID
				AND GP.[ID] = ER.[IdGroup] 
		LEFT JOIN dbo.[HistoricSubGroup] (NOLOCK) SGP
			ON SGP.[VCC] = ER.[Instance]
				AND SGP.[EvaluationPlanId] = EP.[ID]
				AND SGP.[ID] = ER.[IdSubGroup] 
		WHERE ER.[Instance] LIKE CASE WHEN @VCC IS NOT NULL THEN @VCC ELSE ER.[Instance] END
			AND EF.[Description] IN (SELECT [Value] FROM [dbo].[Split](IIF(@Format IS NULL, EF.[Description], @Format), ','))
			AND EP.[Description] IN (SELECT [Value] FROM [dbo].[Split](IIF(@Plan IS NULL, EP.[Description], @Plan), ','))
			AND ER.[CampaignDescription] IN (SELECT [Value] FROM [dbo].[Split](IIF(@HistoricCampaign IS NULL, ER.[CampaignDescription], @HistoricCampaign), ','))
			AND ER.[AgentDescription] IN (SELECT [Value] FROM [dbo].[Split](IIF(@IdAgente IS NULL, ER.[AgentDescription], @IdAgente), ','))
			AND ER.[IdAuditor] IN (SELECT [Value] FROM [dbo].[Split](IIF(@IdAuditor IS NULL, ER.[IdAuditor], @IdAuditor), ','))
			AND AEP.[TimeStamp] >=
                          CASE
                            WHEN @StartDate IS NOT NULL THEN @StartDate
                            ELSE '19800101'
                          END
			AND AEP.[TimeStamp] <
                         CASE
                           WHEN @EndDate IS NOT NULL THEN @EndDate + ' 23:59'
                           ELSE '20500101'
                         END
		  --AND EP.[Status] = 7
		  AND AEP.[Completed] = 1
		  AND AEP.[StatusDescription] NOT IN('INVALID')
	) a

	--select * from #TempEvaluationResult ORDER BY IdInteraction


  SET @cols = STUFF((SELECT DISTINCT
    ',' + QUOTENAME(Ability) 
  FROM #TempEvaluationResult
  FOR xml PATH (''), TYPE)
  .value('.', 'varchar(Max)')
  , 1, 1, '')

  --Select @cols
  IF @cols IS NOT NULL
  BEGIN

    DECLARE @type varchar(max)=(Select Top 1 Evaluation_Mode From #TempEvaluationResult)

    DECLARE @Total varchar(max) = STUFF((SELECT DISTINCT
      '+ ISNULL(' + QUOTENAME(Ability) + ',0)'
    FROM #TempEvaluationResult
    FOR xml PATH (''), TYPE)
    .value('.', 'varchar(Max)')
    , 1, 1, '')
    --SELECT @type
	If @type = 'M'
	BEGIN
    SET @query = ' 
				SELECT p.[VCC]							[VCC],
						p.[DescriptionPlan]				[EVALUATION_PLAN],
						p.[DescriptionFormat]			[EVALUATION_FORMAT],
						p.[AgentDescription]			[AGENT],
  						p.[CampaignDescription]			[CAMPAIGN],
						p.[IdInteraction]				[INTERACTION],
						p.[EvaluationDate]				[EVALUATION_DATE],
						p.[IdAuditor]					[AUDITOR],
						[InteractionDuration]			[DURATION_TIME], 
						NULL							[PHONE],
						[InteractionDateStart]			[START_DATE],
						NULL							[CATEGORY],
						-- (' + @Total + ')				[COLUMN_TOTAL_SCORE], 
						p.[Score]						[COLUMN_TOTAL_SCORE], 
						p.[AutomaticScore]				[COLUMN_AUTOMATIC_SCORE],
						p.[ManualScore]					[COLUMN_MANUAL_SCORE],
						' + @cols + ' 
					FROM 
				( select VCC,
							DescriptionPlan,
							DescriptionFormat,
							Ability,
							AgentDescription,
							CampaignDescription,
							IdInteraction,
							EvaluationDate,
							Qualification,
							Score,
							AutomaticScore,
							ManualScore,
							IdAuditor			
						from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join (
				Select Distinct IdInteraction,InteractionDuration,InteractionDateStart From InteractionEvaluationPlan (Nolock) 
				) as A On
				A.IdInteraction = p.IdInteraction '
    END
	ELSE 
	BEGIN
    SET @query = ' 
				Select p.[VCC]							[VCC],
						p.[DescriptionPlan]				[EVALUATION_PLAN],
						p.[DescriptionFormat]			[EVALUATION_FORMAT],
						p.[AgentDescription]			[AGENT],
  						p.[CampaignDescription]			[CAMPAIGN] ,
						p.[IdInteraction]				[INTERACTION] ,
						p.[EvaluationDate]				[EVALUATION_DATE],
						p.[IdAuditor]					[AUDITOR],
						A.[DurationTime]				[DURATION_TIME],
						A.[Number]						[PHONE] ,
						A.[StartDate]					[START_DATE] ,
						A.[Category1]					[CATEGORY] ,
						-- (' + @Total + ')				[COLUMN_TOTAL_SCORE], 
						p.[Score]						[COLUMN_TOTAL_SCORE], 
						p.[AutomaticScore]				[COLUMN_AUTOMATIC_SCORE],
						p.[ManualScore]					[COLUMN_MANUAL_SCORE],
						' + @cols + ' 
					from ( 
						select VCC,
								DescriptionPlan,
								DescriptionFormat,
								Ability,
								AgentDescription,
								CampaignDescription,
								IdInteraction,
								EvaluationDate,
								Qualification,
								Score,
								AutomaticScore,
								ManualScore,
								IdAuditor			
							from #TempEvaluationResult
					) x pivot 
					( 
						 max(Qualification)
						for Ability in (' + @cols + ')
					) p 
					LEFT Join Audio as A 
						On A.[VCC] = p.[VCC]
							AND A.ID = p.IdInteraction'
	END
	--Print(@query)
    EXECUTE (@query)
    DROP TABLE #TempEvaluationResult
  END
  ELSE
  BEGIN
    SELECT
						''				As [EVALUATION_PLAN],
						''				As [EVALUATION_FORMAT],
						''				As [AGENT],
  						''			    As [CAMPAIGN] ,
						''			 	As [INTERACTION] ,
						''				As [EVALUATION_DATE],
						''				As [AUDITOR]
  END
  
  SET NOCOUNT OFF
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
