SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[ReportBySummaryFormat] (@VCC varchar(50) = NULL, @Campana varchar(50) = NULL, @Plan varchar(50) = NULL,
@Formato varchar(50) , @FechaInicial varchar(50) = NULL, @FechaFinal varchar(50) = NULL , @IdAuditor varchar(50) = NULL ,@IdAgente varchar(50) = NULL)
AS
  DECLARE @cols varchar(max)
  DECLARE @query varchar(max)
  --ReportBySummaryFormat 'allegro','entrantes',NULL,'nov01-0356',NULL,NULL,NULL,'icagente2'
  --SET @Formato = 'nov01-0356'
  SET NOCOUNT ON
  SELECT
    * INTO #TempEvaluationResult
  FROM (SELECT
    EP.Description AS 'DescriptionPlan',
    EF.Description AS 'DescriptionFormat',
    GP.Description + '-' + SGP.Description + '-' + A.Title AS 'Ability',
    ER.AgentDescription,
    ER.CampaignDescription,
    ER.IdInteraction,
    ER.Qualification,
    Format(ER.EvaluationDate, 'dd/MM/yyyy hh:mm:ss') AS 'EvaluationDate',
    ER.IdAuditor,
    EP.Evaluation_Mode
  FROM EvaluationResult (NOLOCK) ER
  LEFT JOIN EvaluationFormat (NOLOCK) EF
    ON ER.IdEvaluationFormat = EF.ID
  LEFT JOIN Ability (NOLOCK) A
    ON A.ID = ER.IdAbility
  LEFT JOIN EvaluationPlan (NOLOCK) EP
    ON EP.ID = ER.IdEvaluationPlan
  LEFT JOIN [Group] (NOLOCK) GP
    ON GP.ID = ER.IdGroup
  LEFT JOIN SubGroup SGP (NOLOCK)
    ON SGP.ID = ER.IdSubGroup
  WHERE EF.Description LIKE CASE
    WHEN @Formato IS NOT NULL THEN @Formato
    ELSE EF.Description
  END
  AND ER.Instance LIKE CASE
    WHEN @VCC IS NOT NULL THEN @VCC
    ELSE ER.Instance
  END
  AND EP.Description LIKE CASE
    WHEN @Plan IS NOT NULL THEN @Plan
    ELSE EP.Description
  END
  AND ER.CampaignDescription LIKE CASE
    WHEN @Campana IS NOT NULL THEN @Campana
    ELSE ER.CampaignDescription
  END
  AND ER.AgentDescription LIKE CASE
    WHEN @IdAgente IS NOT NULL THEN @IdAgente
    ELSE ER.AgentDescription
  END
  AND ER.IdAuditor LIKE CASE
    WHEN @IdAuditor IS NOT NULL THEN @IdAuditor
    ELSE ER.IdAuditor
  END
  AND ER.EvaluationDate >=
                          CASE
                            WHEN @FechaInicial IS NOT NULL THEN @FechaInicial
                            ELSE '19800101'
                          END
  AND ER.EvaluationDate <
                         CASE
                           WHEN @FechaFinal IS NOT NULL THEN @FechaFinal + ' 23:59'
                           ELSE '20500101'
                         END) a



  SET @cols = STUFF((SELECT DISTINCT
    ',' + QUOTENAME(Ability)
  FROM #TempEvaluationResult
  FOR xml PATH (''), TYPE)
  .value('.', 'varchar(Max)')
  , 1, 1, '')
  --Select @cols
  IF @cols IS NOT NULL
  BEGIN
    ------
    DECLARE @type varchar(max) = (SELECT TOP 1
      Evaluation_Mode
    FROM #TempEvaluationResult)
	-------
    DECLARE @Total varchar(max) = STUFF((SELECT DISTINCT
      '+ ISNULL(' + QUOTENAME(Ability) + ',0)'
    FROM #TempEvaluationResult
    FOR xml PATH (''), TYPE)
    .value('.', 'varchar(Max)')
    , 1, 1, '')    
	-- ROUND(AVG(CAST(ER.Qualification AS float)), 2) AS 'Qualification',
    DECLARE @colavg varchar(max) = STUFF((SELECT DISTINCT
      ', ROUND(AVG(CAST(q.' + QUOTENAME(Ability) + ' AS float)), 2) As [' + Ability + ' Promedio]'
    FROM #TempEvaluationResult
    FOR xml PATH (''), TYPE)
    .value('.', 'varchar(Max)')
    , 1, 1, '')

    --SELECT @colavg
    IF @type = 'M'
    BEGIN
      SET @query = ' 
				Select q.DescriptionPlan As [Plan] ,q.DescriptionFormat As Formato ,q.AgentDescription As Agente ,q.CampaignDescription As Campana ,count(q.IdInteraction) As Auditorias,
				sum(q.DurationTime) As [Tiempo Duracion],ROUND(AVG(CAST(q.Note AS float)), 2) As [Nota Promedio], ' + @colavg + ' From
				(Select p.DescriptionPlan,p.DescriptionFormat,p.AgentDescription,
  				p.CampaignDescription,p.IdInteraction,p.EvaluationDate,p.IdAuditor,InteractionDuration as DurationTime, 
				null As Number,InteractionDateStart As StartDate,null As Category1,(' + @Total + ') As Note, ' + @cols + ' from 
				( select DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join (
				Select Distinct IdInteraction,InteractionDuration,InteractionDateStart From InteractionEvaluationPlan (Nolock)
				) as A On
				A.IdInteraction=p.IdInteraction)q
				Group By 
				q.DescriptionPlan,q.DescriptionFormat,q.AgentDescription,q.CampaignDescription
				'
    END
    ELSE
    BEGIN
      SET @query = '
	
			    Select q.DescriptionPlan As Plan ,q.DescriptionFormat As Formato ,q.AgentDescription As Agente,q.CampaignDescription As [Campana,count(q.IdInteraction) As Auditorias,
				sum(q.DurationTime) As [Tiempo Duraccion],ROUND(AVG(CAST(q.Note AS float)), 2) As [Nota Promedio], ' + @colavg + ' From 
				(Select p.DescriptionPlan,p.DescriptionFormat,p.AgentDescription,
  				p.CampaignDescription,p.IdInteraction,p.EvaluationDate,p.IdAuditor,
				A.DurationTime,A.Number,A.StartDate,A.Category1,(' + @Total + ') As Note, ' + @cols + ' from 
				( select DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join Audio as A On
				A.ID=p.IdInteraction)q
				Group By 
				q.DescriptionPlan,q.DescriptionFormat,q.AgentDescription,q.CampaignDescription'
    END
    --Print(@query)
    EXECUTE (@query)
    --Select * From @query

    DROP TABLE #TempEvaluationResult
  END
  ELSE
  BEGIN
    DROP TABLE #TempEvaluationResult
    SELECT
      '' AS [Plan],
      '' AS Formato,
      '' AS Agente,
      '' AS [Campana]
  END
  SET NOCOUNT OFF 
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
