SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveAPIUser] (
	@VCC VARCHAR(50) = NULL, 					@User VARCHAR(50) = NULL, 				@CreatedDate DATETIME = NULL,			
	@CreatedByUserId VARCHAR(50) = NULL,    	@LastModifiedDate DATETIME = NULL,		@LastModifiedByUserId VARCHAR(50) = NULL,
	@IsLocked BIT = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [UserAPI]
	SET [IsLocked] = @IsLocked,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
	AND [User] = @User
    
    IF @@ROWCOUNT = 0
		INSERT INTO [UserAPI] (
			[VCC], [User], [IsLocked],
			[CreatedDate], [CreatedByUserId],
			[LastModifiedDate], [LastModifiedByUserId],
			[TimeStamp]
			)
		VALUES (
			@VCC, @User, @IsLocked,
			@CreatedDate, @CreatedByUserId,
			@LastModifiedDate, @LastModifiedByUserId,
			GETUTCDATE()
		)
		
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
