SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveAbility] (
	@Instance Varchar(50) = NULL, 				
	@ID Varchar(50) = NULL,
	@Title Varchar(100) = NULL,					
	@Detail Varchar(500) = NULL,
	@Type VARCHAR(25) = NULL, -- MANUAL/MANUAL_AUTOMATIC/MIXED
	@CalificationType VARCHAR(25) = NULL, -- QUALITATIVE/QUANTITATIVE
	@Binary Bit = NULL,
	@NotApply Bit = NULL,
	@Distribute BIT = NULL,
	@AcceptComments Bit = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,
	@Enabled bit = NULL,
	@AnalysisType VARCHAR(25) = NULL,
	@Language VARCHAR(50) = NULL,
	@IsNegative BIT = NULL,
    @DegradeScoreCard BIT = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	-- FLAG PARA EL DEGRADADO DE SCORE CARD
    UPDATE [AbilityScoreCard]
        SET [DegradeScoreCard] = @DegradeScoreCard
        WHERE [VCC] = @Instance 
			AND [ID] = @ID
    IF @@ROWCOUNT = 0
		INSERT INTO [AbilityScoreCard] (
			[VCC], [ID], [DegradeScoreCard]
		) VALUES(
			@Instance, @ID, @DegradeScoreCard
		)

	-- EN CASO NOT_APPLY SEA FALSE, SETTEAMOS DISTRIBUTE COMO FALSE
	IF @NotApply = 0 SET @Distribute = 0
	IF @Distribute IS NULL SET @Distribute = 0
	
	-- 
	UPDATE [Ability]
		SET [Title] = @Title,
			[Detail] = @Detail,
			[Type] = @Type,
			[CalificationType] = @CalificationType,
			[Binary] = @Binary,
			[NotApply] = @NotApply, 
			[Distribute] = @Distribute, 
			[AcceptComments] = @AcceptComments,
			[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
			[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
			[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[Enabled] = CASE WHEN @Enabled IS NULL THEN 1 ELSE @Enabled END,
			[TimeStamp] = GETUTCDATE(),
			[AnalysisType] = @AnalysisType,
			[Language] = @Language,
			[IsNegative] = @IsNegative
		WHERE [Instance] = @Instance
			AND [ID] = @ID

    IF @@ROWCOUNT = 0
		INSERT INTO [Ability] (
			[Instance], [ID],
			[Title], [Detail], 
			[Type], [CalificationType],
			[Binary], [NotApply], 
			[Distribute], [AcceptComments],
			[CreatedDate], [CreatedByUserId], 
			[LastModifiedDate], [LastModifiedByUserId],
			[Enabled], [TimeStamp], 
			[AnalysisType], [Language], 
			[IsNegative]
			)
		VALUES (
			@Instance, @ID,
			@Title, @Detail, 
			@Type, @CalificationType,
			@Binary, @NotApply, 
			@Distribute, @AcceptComments, 
			@CreatedDate, @CreatedByUserId, 
			@LastModifiedDate, @LastModifiedByUserId,
			1, GETUTCDATE(), 
			@AnalysisType, @Language, @IsNegative
		)

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
