SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveAbilityQuery] (
	@VCC							VARCHAR(50) = NULL,
	@ID								VARCHAR(50) = NULL,
	@AbilityId						VARCHAR(50) = NULL,
	@QueryId						VARCHAR(50) = NULL,
	@QueryContent					VARCHAR(1000) = NULL,
	@AcceptancePercentage			DECIMAL(18, 2) = NULL,
	@Order							INT = NULL,
	@CreatedByUserId				VARCHAR(50) = NULL,
	@LastModifiedByUserId			VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [AbilityQuery]
		SET [AcceptancePercentage] = @AcceptancePercentage,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[LastModifiedDate] = GETUTCDATE(),
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [ID] = @ID

	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [AbilityQuery] (
			[VCC], [ID], [AbilityId], [QueryId], [QueryContent],
			[AcceptancePercentage], [Order], [CreatedDate], [CreatedByUserId], [LastModifiedDate], 
			[LastModifiedByUserId], [TimeStamp]
		)
		VALUES (
			@VCC, @ID, @AbilityId, @QueryId, @QueryContent, 
			@AcceptancePercentage, @Order, GETUTCDATE(), @CreatedByUserId, GETUTCDATE(), 
			@LastModifiedByUserId, GETUTCDATE()
		)
	END

	SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
