SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveAbilityQueryEntity] (
	@VCC							VARCHAR(50) = NULL,
	@AbilityQueryId					VARCHAR(50) = NULL,
	@EntityId						VARCHAR(50) = NULL,
	@EntityName						VARCHAR(50) = NULL,
	@AcceptancePercentage			DECIMAL(18, 2) = NULL,
	@Order							INT = NULL,
	@CreatedByUserId				VARCHAR(50) = NULL,
	@LastModifiedByUserId			VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [AbilityQueryEntity]
		SET [AcceptancePercentage] = @AcceptancePercentage,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[LastModifiedDate] = GETUTCDATE(),
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [AbilityQueryId] = @AbilityQueryId
			AND [EntityId] = @EntityId

	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [AbilityQueryEntity] (
			[VCC], [AbilityQueryId], [EntityId], [EntityName], [AcceptancePercentage], 
			[Order], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], 
			[TimeStamp]
		)
		VALUES (
			@VCC, @AbilityQueryId, @EntityId, @EntityName, @AcceptancePercentage, 
			@Order, GETUTCDATE(), @CreatedByUserId, GETUTCDATE(), @LastModifiedByUserId, 
			GETUTCDATE()
		)
	END

	SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
