SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveCustomFieldResult] (
	@VCC VARCHAR(50) = NULL, 				
	@ID VARCHAR(100) = NULL,
	@Description VARCHAR(150) = NULL,
	@Order INT = NULL,
	@CustomFieldId VARCHAR(100) = NULL,
	@CreatedByUserId VARCHAR(50) = NULL,
	@LastModifiedByUserId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [CustomFieldResult]
		SET [Description] = @Description,
			[Order] = @Order,
			[LastModifiedDate] = GETUTCDATE(),
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [ID] = @ID
			AND [CustomFieldId] =  @CustomFieldId

    IF @@ROWCOUNT = 0
		INSERT INTO [CustomFieldResult] (
			[VCC], 
			[ID],
			[Description], 
			[Order],
			[CustomFieldId],
			[CreatedDate],
			[CreatedByUserId],
			[TimeStamp]
		)
		VALUES (
			@VCC, 
			@ID,
			@Description, 
			@Order,
			@CustomFieldId,
			GETUTCDATE(),
			@CreatedByUserId,
			GETUTCDATE()
		)

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
