SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE procedure [dbo].[SaveEvaluationEfectivitySample](
@VCC varchar(50),
@EfectivityPlanId varchar(50),
@EvaluationPlanId varchar(50),
@AuditorId varchar(50),
@SampleSize int
)
AS
BEGIN
	    
		IF (@SampleSize = -1)
		BEGIN
		UPDATE [dbo].[EvaluationResultEfectivity] 
			SET [AuditorId] = @AuditorId,
				[LastModifiedDate] = GETUTCDATE()
			WHERE 
			[VCC] = @VCC
			AND [EfectivityPlanId] = @EfectivityPlanId
			AND [EvaluationPlanId] = @EvaluationPlanId

			SELECT 1 AS 'result'
		END	

		ELSE
		BEGIN
			IF NOT EXISTS (SELECT 1 FROM [dbo].[EvaluationResultEfectivity] (NOLOCK) WHERE [VCC] = @VCC
			AND [EfectivityPlanId] = @EfectivityPlanId
			AND [EvaluationPlanId] = @EvaluationPlanId  )
			BEGIN 
				CREATE TABLE #RANDOM_INTERACTION(
				[IdInteraction] VARCHAR(250)
				)
				INSERT INTO #RANDOM_INTERACTION
				SELECT TOP (@SampleSize) [IEP].[IdInteraction]
										FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK) 
										WHERE IEP.[Instance] = @VCC
											  AND [IEP].[IdEvaluationPlan] = @EvaluationPlanId
											 -- AND IEP.[InteractionType] = @CURRENT_CHANNEL
										GROUP BY [IEP].[IdInteraction] 
										ORDER BY NEWID()

		

				INSERT INTO [dbo].[EvaluationResultEfectivity]						
				SELECT ER.[Instance],@EfectivityPlanId,ER.[IdEvaluationPlan],ER.[IdInteraction],ER.[IdAgent],ER.[IdAbilityEvaluationFormat],@AuditorId ,null,'CREATED',GETUTCDATE(),GETUTCDATE() 
				FROM [dbo].[EvaluationResult] ER (NOLOCK)
				INNER JOIN #RANDOM_INTERACTION RI ON 
				ER.IdInteraction = RI.IdInteraction 
				WHERE ER.Instance = @VCC AND
				ER.IdEvaluationPlan = @EvaluationPlanId

				SELECT 1 AS 'result'

			END
			ELSE
			BEGIN
			SELECT 0 AS 'result' FROM [dbo].[EvaluationResultEfectivity] WHERE [VCC] = @VCC
			AND [EfectivityPlanId] = @EfectivityPlanId
			AND [EvaluationPlanId] = @EvaluationPlanId
				
			END

			
		END

		
			
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
