SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveEvaluationFormatCustomField] (
	@VCC VARCHAR(50) = NULL, 
	@ID VARCHAR(50) = NULL,
	@EvaluationFormatId VARCHAR(50) = NULL,
	@CustomFieldId VARCHAR(100) = NULL,
	@Order Int = NULL,
	@CreatedByUserId VARCHAR(50) = NULL,
	@LastModifiedByUserId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [EvaluationFormatCustomField]
		SET [Order] = @Order,
			[LastModifiedDate] = GETUTCDATE(),
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [EvaluationFormatId] = @EvaluationFormatId
			AND [CustomFieldId] = @CustomFieldId

    IF @@ROWCOUNT = 0
		INSERT INTO [EvaluationFormatCustomField] (
			[VCC], 
			[ID],
			[EvaluationFormatId],
			[CustomFieldId],
			[Order], 
			[CreatedDate],
			[CreatedByUserId],
			[TimeStamp]
		)
		VALUES (
			@VCC, 
			@ID,
			@EvaluationFormatId,
			@CustomFieldId, 
			@Order,
			GETUTCDATE(),
			@CreatedByUserId,
			GETUTCDATE()
		)

	SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
