SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[SaveEvaluationResultEfectivity] (
	@VCC Varchar(50) = NULL,
	@EfectivityPlanId Varchar(50) = NULL,
	@EvaluationPlanId Varchar(50) = NULL,
	@InteractionId Varchar(250) = NULL,	
	@AbilityEvaluationFormatId Varchar(50) = NULL,	
	@Efectivity Varchar(50) = NULL,
	@EfectivityStatus Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON


	IF EXISTS(SELECT 1 FROM dbo.[EvaluationResultEfectivity](NOLOCK)
			  WHERE VCC = @VCC 
			  AND [EfectivityPlanId] = @EfectivityPlanId
			  AND [EvaluationPlanId] = @EvaluationPlanId
			  AND [InteractionId] = @InteractionId			  
			  AND [AbilityEvaluationFormatId] = @AbilityEvaluationFormatId
			  )
	BEGIN
	UPDATE [dbo].[EvaluationResultEfectivity] 
			SET [Efectivity] = @Efectivity,								   								
				[EfectivityStatus] = @EfectivityStatus,
				[LastModifiedDate] = GETUTCDATE()
				
			 WHERE [VCC] = @VCC 
			  AND [EfectivityPlanId] = @EfectivityPlanId
			  AND [EvaluationPlanId] = @EvaluationPlanId
			  AND [InteractionId] = @InteractionId			  
			  AND [AbilityEvaluationFormatId] = @AbilityEvaluationFormatId
    END 

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
