SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[SaveHistoricStudyData] (
	@VCC VARCHAR(50) =        NULL,
	@StudyId    VARCHAR(50) = NULL,
	@TemplateId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON
	  
	-- INSERTAMOS LA DATA DE LA PLANTILLA
	INSERT INTO [dbo].[HistoricTemplate] 
		SELECT T.[VCC],
				T.[Name],
				T.[Type],
				T.[Description],
				T.[Template],
				T.[Category],
				@StudyId
			FROM [dbo].[Template] T (NOLOCK)
			WHERE T.[Name] = @TemplateId 
				AND T.[VCC] = @VCC

	-- INSERTAMOS LA DATA DE LOS TEMAS
	INSERT INTO [dbo].[HistoricTemplateTheme]
		SELECT TT.[VCC],
				TT.[TemplateId],
				TT.[ID],
				TT.[Order],
				TT.[Description],
				TT.[Category1],
				TT.[Category2],
				TT.[AnalysisType],
				TT.[IsNegative],
				@StudyId
			FROM [dbo].[TemplateTheme] TT (NOLOCK)
			WHERE TT.[TemplateId] = @TemplateId 
				AND TT.[VCC] = @VCC

	-- INSERTAMOS LA DATA DE LOS THEMEITEMS
	INSERT INTO [dbo].[HistoricTemplateThemeItem]
		SELECT TTI.[VCC],
				TTI.[TemplateId],
				TTI.[TemplateThemeId],
				TTI.[ID],
				TTI.[AcceptancePercentage],
				@StudyId
			FROM [dbo].[TemplateThemeItem] TTI (NOLOCK)
			WHERE TTI.[TemplateId] = @TemplateId 
				AND TTI.[VCC] = @VCC

	-- INSERTAMOS LA DATA DE THEMEITEMENTITY
	INSERT INTO [dbo].[HistoricTemplateThemeItemEntity]
		SELECT TTIE.[VCC],
				TTIE.[TemplateId],
				TTIE.[TemplateThemeId],
				TTIE.[TemplateThemeItemId],
				TTIE.[EntityId],
				TTIE.[EntityName],
				TTIE.[AcceptancePercentage],
				TTIE.[Order],
				@StudyId
			FROM [dbo].[TemplateThemeItemEntity] TTIE (NOLOCK)
			WHERE TTIE.[TemplateId] = @TemplateId 
				AND TTIE.[VCC] = @VCC

	-- INSERTAMOS LA DATA DE LOS QUERY (SE USA?)
	INSERT INTO [dbo].[HistoricGenericTemplateQuery]
		SELECT GTQ.[VCC],
				GTQ.[TemplateId],
				GTQ.[ID],
				GTQ.[Query],
				@StudyId
			FROM [dbo].[GenericTemplateQuery] GTQ (NOLOCK)
            WHERE GTQ.[TemplateId] = @TemplateId 
				AND GTQ.[VCC] = @VCC

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
