SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[SaveScoreTipificationItem] (
	@VCC VARCHAR(50) = NULL, 	
	@ScoreId VARCHAR(50) = NULL,
	@ID VARCHAR(50) = NULL,
	@TipificationId VARCHAR(50) = NULL,
	@SecondLevelItemId VARCHAR(50) = NULL,
	@Description VARCHAR(250) = NULL,					
	@Order INT = NULL,
	@UserId VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- ACTUALIZAMOS EN CASO EXISTA
	UPDATE [ScoreTipificationItem]
		SET [Description] = @Description,
			[Order] = @Order,
			[LastModifiedDate] = GETUTCDATE(),
			[LastModifiedByUserId] = @UserId
		WHERE [VCC] = @VCC
			AND [ScoreId] = @ScoreId
			AND [TipificationId] = @TipificationId
			AND [ID] = @ID

    IF @@ROWCOUNT = 0
		INSERT INTO [ScoreTipificationItem] (
			[VCC], 
			[ScoreId],
			[TipificationId], 
			[ID],
			[SecondLevelItemId],
			[Description], 
			[Order], 
			[CreatedDate],
			[CreatedByUserId]
			)
		VALUES (
			@VCC, 
			@ScoreId,
			@TipificationId,
			@ID,
			@SecondLevelItemId,
			@Description, 
			@Order,
			GETUTCDATE(),
			@UserId
		)

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
