SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveStudyBaseResult] (
	@VCC VARCHAR(50) = NULL,
	@STUDY_ID VARCHAR(100) = NULL
) AS
BEGIN
	-- ESTE SP INSERTA LOS RESULT BASE DE UN ESTUDIO
	SET NOCOUNT ON
	--DECLARE 	@VCC VARCHAR(50) = 'incollege'
	--DECLARE @STUDY_ID VARCHAR(100) = 'positive-study-2'


/************************ SECTOR PARA INSERTAR EN StudyResultSummaryDetail INTERACCIONES DE TIPO CALL **************/
	;WITH CTE_CALL AS (
		SELECT S.[TemplateId],
				TTI.[TemplateThemeId]		'TemplateThemeId',
				TTI.[ID]					'TemplateThemeItemId',
              CONCAT(
				PA.[AudioId],
				'_',
				ISNULL(PA.[Section], '0'),
				'_',
				ISNULL(PA.[Part], '0'))		'TranscriptionId'
			FROM [dbo].[Study] S (NOLOCK) 
			JOIN [dbo].[TemplateThemeItem] TTI (NOLOCK) 
				ON (
					S.[VCC] = TTI.[VCC] 
					AND S.[TemplateId] = TTI.[TemplateId]
				)
			JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON (
					PA.[VCC] = S.[VCC] 
					AND PA.[ProcessId] = S.[ProcessId]
				)
			JOIN [dbo].[Audio] A (NOLOCK) 
				 ON (
					A.[VCC] = S.[VCC] 
					AND A.[ID] = PA.[AudioId]
				)
			LEFT JOIN [dbo].[StudyResultSummaryDetail] SRSD (NOLOCK)
				ON (
					S.[VCC] = SRSD.[VCC]
					AND S.[Name] = SRSD.[StudyId]
					AND TTI.[TemplateThemeId] = SRSD.[TemplateThemeId]
					AND TTI.[ID] = SRSD.[TemplateThemeItemId]
					AND CONCAT(PA.[AudioId], '_', ISNULL(PA.[Section], '0'), '_', ISNULL(PA.[Part], '0')) = SRSD.TranscriptionId
				)
			WHERE S.[VCC] = @VCC 
				AND S.[Name] = @STUDY_ID 
				AND A.[Channel] ='CALL' 
				AND SRSD.TemplateThemeId IS NULL
			GROUP BY S.[TemplateId],
						TTI.[TemplateThemeId],
						TTI.[ID],
						PA.[AudioId],
						PA.[Section],
						PA.[Part]
    )

        
	INSERT INTO [dbo].[StudyResultSummaryDetail] (
        [VCC],
        [StudyId],
        [TemplateThemeId],
        [TemplateThemeItemId],
        [TranscriptionId],
        [CreatedDate],
        [CreatedByUserId],
        [TimeStamp],
        [IsMatched]
    )
        SELECT @VCC,
				@STUDY_ID,
				[TemplateThemeId],
				[TemplateThemeItemId],
				[TranscriptionId], 
				GETUTCDATE(),
				'system',
				GETUTCDATE(),
				0 --0 POR DEFECTO PARA ACTUALIZAR MAS ADELANTE A 1 EN EL BULK LOS QUE HICIERON MATCH
			FROM CTE_CALL

/************************ SECTOR PARA INSERTAR StudyResultSummaryDetail INTERACCIONES ASINCRONAS ******************/

	;WITH CTE_ASYNC AS (
		SELECT S.[TemplateId],
				TTI.[TemplateThemeId]			'TemplateThemeId',
				TTI.[ID]						'TemplateThemeItemId',
				CONCAT(
					PAI.[InteractionType], 
					'_', 
					PAI.[Campaign], 
					'_', 
					PAI.[FormattedEndDate], 
					'_', 
					REPLACE(PAI.[InteractionId], ':', '_')
				)								'TranscriptionId'
			FROM  [dbo].[Study] S (NOLOCK) 
			JOIN [dbo].[TemplateThemeItem] TTI (NOLOCK) 
				ON (
					S.[VCC] = TTI.[VCC] 
					AND S.[TemplateId] = TTI.[TemplateId]
				)
			JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK) 
				ON (
					PAI.[VCC] = S.[VCC] 
					AND PAI.[ProcessId] = S.[ProcessId]
					)
			LEFT JOIN [dbo].[StudyResultSummaryDetail] SRSD (NOLOCK)
				ON (
					S.[VCC] = SRSD.[VCC] 
					AND S.[Name] = SRSD.[StudyId] 
					AND TTI.[TemplateThemeId] = SRSD.[TemplateThemeId] 
					AND TTI.[ID] = SRSD.[TemplateThemeItemId] 
					AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = SRSD.TranscriptionId
				)
			WHERE S.[VCC] = @VCC 
				AND S.[Name] = @STUDY_ID 
				AND SRSD.TemplateThemeId IS NULL
			GROUP BY S.[TemplateId],
						TTI.[TemplateThemeId],
						TTI.[ID],
						PAI.[InteractionType],
						PAI.[Campaign],
						PAI.[FormattedEndDate],
						PAI.[InteractionId]
	)

    INSERT INTO [dbo].[StudyResultSummaryDetail] (
		[VCC],
		[StudyId],
		[TemplateThemeId],
		[TemplateThemeItemId],
		[TranscriptionId],
		[CreatedDate],
		[CreatedByUserId],
		[TimeStamp],
		[IsMatched]
    )
		SELECT @VCC,
				@STUDY_ID,
				[TemplateThemeId],
				[TemplateThemeItemId],
				[TranscriptionId], 
				GETUTCDATE(),
				'system',
				GETUTCDATE(),
				0 --0 POR DEFECTO PARA ACTUALIZAR MAS ADELANTE A 1 EN EL BULK LOS QUE HICIERON MATCH
			FROM CTE_ASYNC

/************************ SECTOR PARA INSERTAR StudyResultSummary INTERACCIONES DEL CANAL CALL **************/
	;WITH CTE_SRS AS (
		 SELECT S.[TemplateId],
				  TT.[ID]				'TemplateThemeId',
				  TT.[Description],
				  TT.[Category1],
				  TT.[Category2]
			FROM [dbo].[Study] S (NOLOCK)
			JOIN [dbo].[TemplateTheme] TT (NOLOCK) 
				ON (
					S.[VCC] = TT.[VCC] 
					AND S.[TemplateId] = TT.[TemplateId]
				)
			JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON (
					PA.[VCC] = S.[VCC] 
					AND PA.[ProcessId] = S.[ProcessId]
				   )
			JOIN [dbo].[Audio] A (NOLOCK) 
				ON (
					A.[VCC] = S.[VCC] 
					AND A.[ID] = PA.[AudioId]
				  )
			LEFT JOIN [dbo].[StudyResultSummary] SRS (NOLOCK)
				ON (
					SRS.[VCC] = S.[VCC] 
					AND SRS.[StudyId] = S.[Name] 
					AND SRS.[TemplateThemeId] = TT.[ID]
				)
			WHERE S.[VCC] = @VCC 
				AND S.[Name] = @STUDY_ID 
				AND A.[Channel] ='CALL' 
				AND SRS.[TemplateThemeId] IS NULL
			GROUP BY S.[TemplateId],
						TT.[ID],
						TT.[Description],
						TT.[Category1], 
						TT.[Category2]
	)

    INSERT INTO [dbo].[StudyResultSummary](
		[VCC],
		[StudyId],
		[TemplateId],
		[TemplateThemeId],
		[ID],
		[Description],
		[Category1],
		[Category2],
		[Total],
		[Duration],
		[Silence],
		[OtherDuration],
		[OtherSilence],
		[Confidence],
		[CreatedDate],
		[CreatedByUserId],
		[LastModifiedDate],
		[LastModifiedByUserId],
		[TimeStamp],
		[IsMatched]
    )
		SELECT @VCC,@STUDY_ID,
				[TemplateId],
				[TemplateThemeId],
				CONVERT(VARCHAR(50), NEWID()),
				[Description],
				[Category1],
				[Category2],
				1,
				NULL,--Duration
				NULL,--Silence
				NULL,--OtherDuration
				NULL,--OtherSilence,
				NULL,--Confidence
				GETUTCDATE(),
				'system',
				GETUTCDATE(),
				'system',
				GETUTCDATE(),
				0
			FROM CTE_SRS


 /******************  SECTOR PARA INSERTAR StudyResultSummary PARA INTERACCIONES  ASINCRONAS   ****************************/


	;WITH CTE_SRS_ASYNC AS (
		SELECT S.[TemplateId],
				TT.[ID] 'TemplateThemeId',
				TT.[Description],
				TT.[Category1],
				TT.[Category2]
			FROM [dbo].[Study] S (NOLOCK)
			JOIN [dbo].[TemplateTheme]  TT (NOLOCK) 
				ON (
					S.[VCC] = TT.[VCC] AND
					S.[TemplateId] = TT.[TemplateId]
				)
			JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK) 
				ON (
					PAI.[VCC] = S.[VCC] AND 
					PAI.[ProcessId] = S.[ProcessId]
				)
			LEFT JOIN [dbo].[StudyResultSummary] SRS (NOLOCK)
				ON (
					SRS.[VCC] = S.[VCC] AND 
					SRS.[StudyId] = S.[Name] AND 
					SRS.[TemplateThemeId] = TT.[ID]
				)
			WHERE S.[VCC] = @VCC 
				AND S.[Name] = @STUDY_ID 
				AND SRS.[TemplateThemeId] IS NULL
			GROUP BY S.[TemplateId],
						TT.[ID],
						TT.[Description], 
						TT.[Category1], 
						TT.[Category2]
	)

	INSERT INTO [dbo].[StudyResultSummary](
		[VCC],
		[StudyId],
		[TemplateId],
		[TemplateThemeId],
		[ID],
		[Description],
		[Category1],
		[Category2],
		[Total],
		[Duration],
		[Silence],
		[OtherDuration],
		[OtherSilence],
		[Confidence],
		[CreatedDate],
		[CreatedByUserId],
		[LastModifiedDate],
		[LastModifiedByUserId],
		[TimeStamp],
		[IsMatched]
	)
		SELECT @VCC,@STUDY_ID,
				[TemplateId],
				[TemplateThemeId],
				CONVERT(VARCHAR(50), NEWID()),
				[Description],
				[Category1],
				[Category2],
				1,
				NULL,--Duration
				NULL,--Silence
				NULL,--OtherDuration
				NULL,--OtherSilence,
				NULL,--Confidence
				GETUTCDATE(),
				'system',
				GETUTCDATE(),
				'system',
				GETUTCDATE(),
				0 --0 POR DEFECTO PARA ACTUALIZAR MAS ADELANTE A 1 EN EL BULK LOS QUE HICIERON MATCH
			FROM CTE_SRS_ASYNC

/**********************  INSERTAR EN  [StudyDetail]  PARA INERACCIONES DE TIPO CALL *********************/
	
	;WITH CTE_SD_CALL AS (
	     SELECT S.[TemplateId],
				TTI.[TemplateThemeId]					'TemplateThemeId',
				TTI.[ID]								'TemplateThemeItemId',
				CONCAT(
					PA.[AudioId],
					'_',
					ISNULL(PA.[Section], '0'),
					'_',
					ISNULL(PA.[Part], '0'))				'TranscriptionId'
			FROM  [dbo].[Study] S (NOLOCK) 
			JOIN [dbo].[TemplateThemeItem] TTI (NOLOCK) 
				ON (
						S.[VCC] = TTI.[VCC] 
						AND S.[TemplateId] = TTI.[TemplateId]
					)
			JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON (
					PA.[VCC] = S.[VCC] 
					AND PA.[ProcessId] = S.[ProcessId]
				)
			JOIN [dbo].[Audio] A (NOLOCK) 
				 ON (
					A.[VCC] = S.[VCC] 
					AND A.[ID] = PA.[AudioId]
				)
			LEFT JOIN [dbo].[StudyDetail] SD (NOLOCK)
				 ON (
					S.[VCC] = SD.[VCC]
					AND S.[Name] = SD.[StudyId]
					AND TTI.[TemplateThemeId] = SD.[TemplateThemeId]
					AND TTI.[ID] = SD.[TemplateThemeItemId]
					AND CONCAT(PA.[AudioId],'_',ISNULL(PA.[Section], '0'),'_',ISNULL(PA.[Part], '0')) = SD.TranscriptionId
                )
			WHERE S.[VCC] = @VCC 
				AND S.[Name] = @STUDY_ID 
				AND A.[Channel] ='CALL' 
				AND SD.TemplateThemeId IS NULL
			GROUP BY S.[TemplateId],
						TTI.[TemplateThemeId],
						TTI.[ID],
						PA.[AudioId],
						PA.[Section],
						PA.[Part]
    )
	
		INSERT INTO [dbo].[StudyDetail] (
			[VCC]
			,[StudyId]
			,[TemplateThemeId]
			,[TemplateThemeItemId]
			,[TranscriptionId]
			,[Total]
			,[Duration]
			,[Silence]
			,[OtherDuration]
			,[OtherSilence]
			,[Confidence]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			,[IsMatched]
		) 
			SELECT @VCC,
					 @STUDY_ID,
					 [TemplateThemeId],
					 [TemplateThemeItemId],
					 [TranscriptionId],
					 1,--Total
					 NULL,--Duration
					 NULL,--Silence
					 NULL,--OtherDuration
					 NULL,--OtherSilence,
					 NULL,--Confidence
					 GETUTCDATE(),
					'system',
					 GETUTCDATE(),
					'system',
					 GETUTCDATE(),
					 0 --IsMatched
				FROM CTE_SD_CALL




	/**********************  INSERTAR EN  [StudyDetail]  PARA INERACCIONES DE ASINCRONAS *********************/
	


	;WITH CTE_SD_ASYNC AS (
		SELECT S.[TemplateId],
				 TTI.[TemplateThemeId]			'TemplateThemeId',
				 TTI.[ID]						'TemplateThemeItemId',
				 CONCAT(
					PAI.[InteractionType], 
					'_', 
					PAI.[Campaign], 
					'_', 
					PAI.[FormattedEndDate], 
					'_', 
					REPLACE(PAI.[InteractionId], ':', '_')) 'TranscriptionId'
		FROM  [dbo].[Study] S (NOLOCK) 
		JOIN [dbo].[TemplateThemeItem] TTI (NOLOCK) 
			ON (
				S.[VCC] = TTI.[VCC] 
				AND S.[TemplateId] = TTI.[TemplateId]
			)
		JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK) 
			ON (
				PAI.[VCC] = S.[VCC] 
				AND PAI.[ProcessId] = S.[ProcessId]
			)
		LEFT JOIN [dbo].[StudyDetail] SD (NOLOCK)
			ON (
				S.[VCC] = SD.[VCC] 
				AND S.[Name] = SD.[StudyId] 
				AND TTI.[TemplateThemeId] = SD.[TemplateThemeId] 
				AND TTI.[ID] = SD.[TemplateThemeItemId] 
				AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = SD.TranscriptionId
			)
		WHERE S.[VCC] = @VCC 
			AND S.[Name] = @STUDY_ID 
			AND SD.TemplateThemeId IS NULL
		GROUP BY S.[TemplateId],
					TTI.[TemplateThemeId],
					TTI.[ID],
					PAI.[InteractionType],
					PAI.[Campaign],
					PAI.[FormattedEndDate],
					PAI.[InteractionId]
	)
	
	INSERT INTO [dbo].[StudyDetail] (
		[VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[Total]
		,[Duration]
		,[Silence]
		,[OtherDuration]
		,[OtherSilence]
		,[Confidence]
		,[CreatedDate]
		,[CreatedByUserId]
		,[LastModifiedDate]
		,[LastModifiedByUserId]
		,[TimeStamp]
		,[IsMatched]
		) 
		SELECT @VCC,
				 @STUDY_ID,
				 [TemplateThemeId],
				 [TemplateThemeItemId],
				 [TranscriptionId],
				 1,--Total
				 NULL,--Duration
				 NULL,--Silence
				 NULL,--OtherDuration
				 NULL,--OtherSilence,
				 NULL,--Confidence
				 GETUTCDATE(),
				'system',
				 GETUTCDATE(),
				'system',
				 GETUTCDATE(),
				 0 --IsMatched
			FROM CTE_SD_ASYNC


	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
