SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveTemplateThemeItemEntity] (
	@VCC							VARCHAR(50) = NULL,
	@TemplateId						VARCHAR(50) = NULL,
	@TemplateThemeId				VARCHAR(50) = NULL,
	@TemplateThemeItemId			VARCHAR(50) = NULL,
	@EntityId						VARCHAR(50) = NULL,
	@EntityName						VARCHAR(50) = NULL,
	@AcceptancePercentage			DECIMAL(18, 2) = NULL,
	@Order							INT = NULL,
	@CreatedByUserId				VARCHAR(50) = NULL,
	@LastModifiedByUserId			VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [TemplateThemeItemEntity]
		SET [AcceptancePercentage] = @AcceptancePercentage,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[LastModifiedDate] = GETUTCDATE(),
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [TemplateId] = @TemplateId
			AND [TemplateThemeId] = @TemplateThemeId
			AND [TemplateThemeItemId] = @TemplateThemeItemId
			AND [EntityId] = @EntityId

	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [TemplateThemeItemEntity] (
			[VCC], [TemplateId], [TemplateThemeId], [TemplateThemeItemId], [EntityId], 
			[EntityName], [AcceptancePercentage], [Order], [CreatedDate], [CreatedByUserId], 
			[LastModifiedDate], [LastModifiedByUserId], [TimeStamp]
		)
		VALUES (
			@VCC, @TemplateId, @TemplateThemeId, @TemplateThemeItemId, @EntityId, 
			@EntityName, @AcceptancePercentage, @Order, GETUTCDATE(), @CreatedByUserId, 
			GETUTCDATE(), @LastModifiedByUserId, GETUTCDATE()
		)
	END
	
	SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
