SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveUtterance]
(
	@VCC						VARCHAR(50),
	@AppId						VARCHAR(50),
	@IntentName					VARCHAR(50),
	@Id							VARCHAR(50),
	@Text						VARCHAR(500),
	@UserId			            VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON
	
	DECLARE @INTENT_ID VARCHAR(50) = NULL
	SELECT @INTENT_ID = [IntentId]
		FROM [dbo].[Intent] (NOLOCK) 
		WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [Name] = @IntentName
	
  
    IF(NOT EXISTS (
		SELECT [Id] 
			FROM [dbo].[Utterance] (NOLOCK) 
			WHERE VCC = @VCC 
				AND [AppId] = @AppId
				AND [IntentId] = @INTENT_ID
				AND [Id] = @Id 
	)) 
	BEGIN
	       
		INSERT INTO [dbo].[Utterance] (
				[VCC],
				[AppId],
				[IntentId],
				[Id],
				[Text],
				[CreatedByUserId],
				[Status],
				[StatusCode]
			)
			VALUES(
				@VCC,
				@AppId,
				@INTENT_ID,
				@Id,
				LOWER(@Text),
				@UserId,
				1,
				'AVAILABLE'
			)
	END

    SELECT [Id] AS 'utteranceId'
		FROM [dbo].[Utterance] (NOLOCK)
	    WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [IntentId] = @INTENT_ID
			AND [Id] = @Id

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
