SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveUtteranceEntity] (
    @VCC				VARCHAR(50) = NULL,
    @UtteranceId		VARCHAR(50) = NULL,
    @EntityName			VARCHAR(50) = NULL,
    @Start				INT = NULL,
    @End				INT = NULL,
    @EndTokenIndex		INT = NULL,
    @StartTokenIndex	INT = NULL
)
AS
BEGIN
	SET NOCOUNT ON
	
	-- VERIFICAMOS SI EL UTTERANCE ENTITY EXISTE
	IF NOT EXISTS(
		SELECT [EntityName] 
			FROM  [dbo].[UtteranceEntity] (NOLOCK) 
			WHERE [VCC] = @VCC 
				AND [UtteranceId] = @UtteranceId 
				AND [EntityName] = @EntityName 
				AND (
					(
						[Start] = @Start
						AND 
						[End] = @End
					)
					OR
					(
						[StartTokenIndex] = @StartTokenIndex
						AND
						[EndTokenIndex] = @EndTokenIndex
					)
				)
	)
	BEGIN
	    INSERT INTO [dbo].[UtteranceEntity] (
			[VCC], [UtteranceId], [EntityName], 
			[Start], [End], [EndTokenIndex], 
			[StartTokenIndex], [CreatedDate]
		) 
		VALUES (
			@VCC, @UtteranceId, @EntityName, 
			@Start, @End, @EndTokenIndex, 
			@StartTokenIndex, GETUTCDATE()
		)
	END
		
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
