SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[SaveWord] (
	@VCC Varchar(50) = NULL, 				@NeuroLinguisticProgrammingId Varchar(50) = NULL, 		@Name Varchar(50) = NULL,
	@ProcessId Varchar(50) = NULL,			@Language Varchar(50) = NULL,							@Type Varchar(50) = NULL,				
	@CreatedDate Datetime = NULL,			@CreatedByUserId Varchar(50) = NULL, 					@LastModifiedDate Datetime = NULL, 		
	@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [Word]
	SET [Type] = @Type,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
	AND [NeuroLinguisticProgrammingId] = @NeuroLinguisticProgrammingId
	AND [Name] = @Name
	AND [ProcessId] = @ProcessId

    IF @@ROWCOUNT = 0
		INSERT INTO [Word] (
			[VCC], [NeuroLinguisticProgrammingId], [Name], [ProcessId], [Language],
			[Type], [CreatedDate], [CreatedByUserId],
			[LastModifiedDate], [LastModifiedByUserId], [TimeStamp]
			)
		VALUES (
			@VCC, @NeuroLinguisticProgrammingId, @Name, @ProcessId, @Language,
			@Type, @CreatedDate, @CreatedByUserId, 
			@LastModifiedDate, @LastModifiedByUserId, GETUTCDATE()
		)

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
